#include "data.h"


data::data(string data_location, string name_org, string name_strand, string name_chr, int T0){

	this->counts_folder=data_location+"/counts/"; //datatype
	this->data_folder=data_location; //datatype
	this->T0=T0; LEN=50000;
	this->sw_window=100;
	this->name_org=name_org;	this->strand=name_strand;	this->crom=name_chr;
	ifstream  file;

	file.open((counts_folder+name_org+".chrom.sizes").c_str());
	if(!file) { cerr<<"Counts input file wrong"<<endl; exit(1);}
	string chr; unsigned int length;

	while (file){
		file>>chr;file>>length;
		if( file.eof() ) break;
		if(crom==chr) {this->T=length;break;}
	}
	if(crom!=chr) {cout<<"Chromosome "<<crom<<" not found in .chrom.sizes file. Exiting the program."<<endl; exit(2);}
    cout<<"Read length of chrom: "<<crom<<" "<< T<<endl;
    file.close();

	counts=new int[T]; for(unsigned int t=0;t<T;t++){counts[t]=0;}
	duplicated=new bool[T]; for(unsigned int t=0;t<T;t++){duplicated[t]=false;}

	context=new double[T];
	seq= new char[T];
}

void	data::read_counts(){

	int temppoz;float   tempcounts, tempdummy;
	string dummy="dummy";
	string countsfile=counts_folder+"counts"+".wig";

	ifstream  file,file2;
	string wigline="variableStep chrom="+crom+" span=1";
	int T1=1; int T2=0;

	file.open((countsfile).c_str());

    if(!file){ cerr<<"File: "<<countsfile<<"  doesn't exist"<<endl; exit(0);}

	//// get to the crom line in multiple wig
    while (wigline.compare(dummy)>0) {
        T1 ++;
        getline(file,dummy);
    }
    getline(file,dummy); // how many lines ot read
    T2=T1;

    while(file.good()&&(!isalpha(dummy.at(0)))) {
        T2++;
        getline(file,dummy);
    }

	file.close();

	for(unsigned int t=0; t<T; t++){counts[t]=0;}
//    cout<<"start reading"<<endl;

	file.open((countsfile).c_str());
	if(strand=="+"){
		for(int t=1; t<(T1); t++){getline(file,dummy);}// cout<<dummy<<endl;file>>temppoz; file>>tempcounts;
		for(int t=T1; t<=T2; t++){
			file>>temppoz; file>>tempcounts; file>>tempdummy;
			if(temppoz<=0||tempcounts<0.10) {continue; }
			temppoz--;
			counts[temppoz]=(int)tempcounts;
			poz_counts.push_back(make_pair(make_pair(crom,strand[0]),make_pair((int)temppoz,(int)tempcounts)));
		}
	}
	else {
		for(int t=1; t<T1; t++){getline(file,dummy);}//file>>temppoz; file>>tempcounts;
		for(int t=T1; t<=T2; t++){
			file>>temppoz; file>>tempdummy; file>>tempcounts;
            if(temppoz<=0||tempcounts<0.10) {continue; }
			counts[T-temppoz]=(int)tempcounts;
			poz_counts.push_back(make_pair(make_pair(crom,strand[0]),make_pair(T-(int)temppoz,(int)tempcounts)));
		}
	}

	file.close();

	cout<<"Finished reading counts. From multiple wig lines "<<T1<<" to "<<T2<<endl;
}


void	data::read_duplicated(){
	//	cout<<t<<" "<<counts[t-T0]<<endl;
	/*
	 * if strand =- read reverse
	 */
	 string dummy;
	cout<<"Read duplication information"<<endl;
	ifstream  file;
	file.open((counts_folder+"duplicated_"+strand+crom+".wig").c_str());
	getline(file,dummy);

	if(strand=="+"){
		for(unsigned int t=0; t<T0; t++){file>>temp;}
		for(unsigned int t=T0; t<T+T0; t++){file>>temp;if(temp<1) duplicated[t-T0]=true; }
	}
	else{
		for(unsigned int t=0; t<T0; t++){file>>temp;}
		for(unsigned int t=T0; t<T+T0; t++){file>>temp;if(temp<1) duplicated[T-1-t+T0]=true; }
	}
	file.close();
}

void	data::read_real(){

	ifstream file;
	file.open((counts_folder+"real"+strand+crom+".wig").c_str());
	if(strand=="+"){
		for(unsigned int t=0; t<T0; t++){file>>temp;}
		for(unsigned int t=T0; t<T+T0; t++){file>>real[t-T0]; }
	}
	else{
		for(unsigned int t=0; t<T0; t++){file>>temp;}
		for(unsigned int t=T0; t<T+T0; t++){file>>real[T-1-t+T0]; }
	}
	file.close();
}
void	data::read_real_struct(){
	ifstream file;
	file.open((counts_folder+"real_struct_"+strand+crom+".wig").c_str());
	if(strand=="+"){
		for(unsigned int t=0; t<T0; t++){file>>temp;}
		for(unsigned int t=T0; t<T+T0; t++){file>>real_struct[t-T0]; }
	}
	else{
		for(unsigned int t=0; t<T0; t++){file>>temp;}
		for(unsigned int t=T0; t<T+T0; t++){file>>real_struct[T-1-t+T0]; }
	}
	file.close();
}

void	data::read_sequence(){
    string fasta_header=">"+crom;
	string dummy="";
	ifstream file;
    string seq_file;
	seq_file=(counts_folder+crom+".fasta");; file.open(seq_file.c_str());
	if(!file) {seq_file=(counts_folder+crom+".fsa"); file.open(seq_file.c_str(), fstream::in);}
	if(!file) {seq_file=(counts_folder+name_org+".fasta");file.open(seq_file.c_str(), fstream::in);}
    if(!file) {seq_file=(data_folder+"/reads/"+name_org+".fasta");file.open(seq_file.c_str(), fstream::in);}
    if(!file) {seq_file=(data_folder+"/reads/"+crom+".fasta");file.open(seq_file.c_str(), fstream::in);}
cout<<endl<<seq_file<<endl;
    if(!file) {
        cerr<<"For chromosome: "<<crom<<"  and organism: "<<name_org<<" there are no fasta or fsa files . Sequence not read; Parametere estimation not done. \n Continue? y or n";
        char resp;cin>>resp;
        while(resp!='y'&&resp!='n') {cout<<"Answer again y or n"<<endl;cin>>resp;}
        cout<<resp<<endl;
        if(resp=='n') exit(0);
    }
    cout<<"Found fasta/fsa file. Reading sequence from: "<<seq_file<<endl;


	while(dummy.find(fasta_header)>1000) 	{getline(file,dummy);}

	if(strand=="+"){
        for(unsigned int t=0; t<T; t++){
		    file>>seq[t];
        }
    }
	else{
		for(unsigned int t=0; t<T; t++){file>>seq[T-1-t]; }
	}
	file.close();

}

datanew::datanew(string counts_folder, string name_org, string name_strand, string name_chr, int T0):data(counts_folder, name_org, name_strand, name_chr,T0){
	ywsum=new int [T];
}

float* datanew::calc_localsum(float* counts,int window_prop){
	float* temp=new float[T];
	temp[0]=0;
	for ( int t=0; t<window_prop; t++) {temp[0]=temp[0]+counts[t];}
	for ( int t=1; t<(T-window_prop); t++) {temp[t]=counts[t+window_prop-1]+temp[t-1]-counts[t-1];}
	for ( unsigned int t=(T-window_prop);t<T; t++) {temp[t]=temp[T-window_prop];}
	return temp;
}



float* datanew::calc_localsum2(float* counts, int window_prop){
	float* temp=new float[T];
	temp[0]=0;
	int half=window_prop/2;
	for (int t=0; t<2*half+1; t++)
        temp[0]=temp[0]+counts[t];
	for (int t=0; t<=half; t++)
        temp[t]=temp[0];
	for (int t=half+1; t<(T-half); t++)
        temp[t]=counts[t+half]+temp[t-1]-counts[t-half-1];
	for (unsigned int t=(T-half);t<T; t++)
        temp[t]=temp[T-half];
        return temp;
}


void datanew::calc_ymean_ymax(){
	ymean=0;ymax=0; yvar=0;
	for ( unsigned int t=0; t<T; t++) {
		ymean=ymean+(float)counts[t]/T;
		yvar=yvar+pow((float)counts[t],2)/T;
		if(ymax<counts[t]) {ymax=(float)counts[t];}
	}
	yvar=yvar-pow(ymean,2);
	yphi=abs(yvar-ymean)/pow(ymean,2);

}


void data::get_initial_particles (string folder,bool continue_iter, double * part_n,double * struct_n,double* param,int* outlier){

    if( continue_iter==1){
        cout<<"Read last particle of previous iterations"<<endl;

        int nr=0;string dummy;int nrtemp;
        ifstream file;
        //////////// get number of lines
        file.open((folder+"Parameters").c_str());
        while(file.good()){	getline(file,dummy);nr++;} nr--;
        file.close();

        //////////// read last line
        nrtemp=nr;
        file.open((folder+"Parameters").c_str());
        while(nrtemp>1){	getline(file,dummy);nrtemp--;}
        while(file.good()){file>>*param;cout<<*param<< " ";param++;}
        file.close();

        //////////// get number of lines
        nr=0;
        file.open((folder+"Particles").c_str());
        while(file.good()){	getline(file,dummy);nr++;} nr--;
        file.close();
        if (nr<2) {
            cout<<"Initializing dummy expression level and local preference particle"<<endl;

            for (unsigned int t=0;t<T;t++){	part_n[t]=2-1*pow(-1.0,(int)t/50);}
            for(unsigned int t=0;t<T;t++) {	struct_n[t]=1-0.5*pow(-1.0,(int)t/10);}

            for(unsigned int t=0;t<T;t++) {	outlier[t]=0;}
        }
        else {
                cout<<"Initiating to the last particle of previous iterations"<<endl;


            //////////// read
            nrtemp=nr;
            file.open((folder+"Particles").c_str());
            while(nrtemp>1){	getline(file,dummy);nrtemp--;}
            for(unsigned int t=0; t<T; t++){file>>part_n[t];}
            file.close();

            nrtemp=nr;
            file.open((folder+"Particles_struct").c_str());
            while(nrtemp>1){	getline(file,dummy);nrtemp--;}
            for(unsigned int t=0; t<T; t++){file>>struct_n[t];}
            file.close();

            nrtemp=nr;
            file.open((folder+"Outlier").c_str());
            while(nrtemp>1){	getline(file,dummy);nrtemp--;}
            for(unsigned int t=0; t<T; t++){file>>outlier[t];}
            file.close();
        }
    }
else{
          cout<<"Initializing dummy expression level and local preference particle"<<endl;

	for (unsigned int t=0;t<T;t++){	part_n[t]=2-1*pow(-1.0,(int)t/50);}
	for(unsigned int t=0;t<T;t++) {	struct_n[t]=1-0.5*pow(-1.0,(int)t/10);}

	for(unsigned int t=0;t<T;t++) {	outlier[t]=0;}
	}
}
