#ifndef DATA_H_
#define DATA_H_

using namespace std;

#include "functions.h"
#include "model.h"

class data {

public:
	string counts_folder,data_folder;
	string name_org;	string strand;string crom;
	string file_counts; string file_sequence;string file_context;
	string file_real; string file_real_struct;  string file_annotation;
	unsigned int T, T0, LEN;

	int* counts;	bool* duplicated;
	vector< pair <pair<string,char>, pair<unsigned int,unsigned int> > > poz_counts;///chr, strand, poz, count ///

	char* seq;
	double* context;int context_window;
	double* real;double* real_struct;
	map <int, int> ann;

	double temp;char tempc;
	float *sw; int sw_window;

public:
	data(){};

	data(string counts_folder,	string name_org, string name_strand, string name_chr,int T0);
	void	read_counts();
	void	read_duplicated();
//	void run_MSEQ(string estimate,string parseq_folder, int context_window,bool nucleotide_influence_present);
//	void compute_context_coeff(string results_folder, bool nucleotide_flag, bool nucleotide_influence_present, int context_window, vector <pair<int,int> > segments);
//	void compute_context(string results_folder, bool nucleotide_flag, bool nucleotide_influence_present, int context_window, vector <pair<int,int> > segments);
//    void read_context(int context_window);

	void get_initial_particles (string folder,bool continue_iter, double * part_n, double * struct_n, double* param,int* outlier);


//  functions needed for the simulation data class
	void	read_real();
	void	read_real_struct();
	void	read_sequence();
	void update_sequence(int* sequence){	for(unsigned int t=0; t<T; t++){seq[t]=sequence[t];}	}
	void update_counts(int* counts){	for(unsigned int t=0; t<T; t++){this->counts[t]=counts[t];}	}
	void update_real(double* real){	for(unsigned int t=0; t<T; t++){this->real[t]=real[t];}	}
	void update_real_struct(double* real_struct){	for(unsigned int t=0; t<T; t++){this->real_struct[t]=real_struct[t];}	}
	void update_context(double* context){	for(unsigned int t=0; t<T; t++){this->context[t]=context[t];}	}

	//	void	get_counts(){ return counts;}
	//	void	get_param(){ return param;}
	//	void	get_context(){ return context;}
	//	void	get_sequence(){ return seq;}
//	virtual ~data(){
//		//		cout<<"calldestructor data"<<endl;
//		//				delete[] counts; delete[] context; delete[] seq;
//		//		if(name_org=="simd") { delete [] real; delete [] real_struct;}
//	}

};

class datanew:public data {
public:
	int* ywsum; bool* dupw;
	double ymax,ymean,yvar,yphi;


public:
	datanew(){};
	datanew(string counts_folder,	string name_org, string name_strand, string name_chr,int T0);
//	virtual ~ datanew(){
//		//		cout<<"destructor DATAnew"<<endl;
//		//		delete [] ywsum;	delete[] proba_move;
//		//		delete[] counts;
//		//		delete[]context;delete[]seq ;
//		//		if(name_org=="simd") { delete[]real;delete[]real_struct;}
//	}
	float* calc_localsum(float* counts,int window_prop);

	float* calc_localsum2(float* counts, int window_prop);
	void calc_proba_move(int WINDOW_alpha_p);
	void calc_ymean_ymax();


};

string* read_algorithm_parameters(string folder_data_param, string file_parsalg,string* names, double * parameters_alg, int npars_alg);
vector <pair<int,int> > read_parameter_update_segments(string folder_data_param, string file_segments,
		int* ind,vector<pair<int,int> >   positions);


#endif /* DATA_H_ */
