#include "estimate_parameters.h"

bedann get_orfs( datanew DATA,bool restart_write){

    /**get codon information**/
//cout<<"getting ORF"<<endl; sleep(5);
    char codons[3][3] ={{'T','A','A'},{'T','G','A'},{'T','A','G'}};
    char codonsrev[3][3] ={{'A','T','T'},{'A','C','T'},{'A','T','C'}};
    bedann ORF;
    unsigned int start[3]={0,0,0};
    pair<string,unsigned int> poz;    pair<unsigned  int,char> poz2;

    string ORFfile= string(DATA.counts_folder+"ORFs"+DATA.strand+".bed");

    /**for each frame get ORFs**/
    ofstream file;
    if(restart_write) file.open((ORFfile).c_str());
    else file.open((ORFfile).c_str(),fstream::app);

     if (DATA.strand=="+"){
        for (unsigned int i=0;i<(DATA.T-5);i=i+3){
            for (unsigned int frame=0; frame<=2; frame++){
                if(!strncmp(DATA.seq+i+frame,codons[0],3)||!strncmp(DATA.seq+i+frame,codons[1],3)||!strncmp(DATA.seq+i+frame,codons[2],3)){
                    if(i-start[frame]>400){
                        file<<DATA.crom<<' '<<start[frame]+100<<' '<<i-100<<' '<<DATA.strand<<' '<<i-start[frame]-100-100+1<<'\n';
                        poz=make_pair(DATA.crom,start[frame]+100);
                        poz2=make_pair(i-100,DATA.strand[0]);
                        (ORF).push_back(make_pair(poz,poz2));
                    }
                    start[frame]=i;
                }
            }
        }
     }
    if (DATA.strand=="-"){
        for (unsigned int i=0;i<DATA.T;i=i+3){
            for (unsigned int frame=0; frame<=2; frame++){
                if(!strncmp(DATA.seq+i+frame,codonsrev[0],3)||!strncmp(DATA.seq+i+frame,codonsrev[1],3)||!strncmp(DATA.seq+i+frame,codonsrev[2],3)){
                    if(i-start[frame]>400){
                        file<<DATA.crom<<' '<<DATA.T-(i-100)<<' '<<DATA.T-(start[frame]+100)<<' '<<DATA.strand<<' '<<i-start[frame]-100-100+1<<'\n';
                        poz=make_pair(DATA.crom,start[frame]+100);
                        poz2=make_pair(i-100,DATA.strand[0]);
                        (ORF).push_back(make_pair(poz,poz2));
                    }
                start[frame]=i;
            }
            }
        }
    }
    file.close();
    return ORF;
}


///*&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&*////
///This function gets all chromosome and strands in a vector of data and annotation
///In the same time it writed the ORFS

vector< pair <datanew,bedann> >  get_datasets(string folder_data_param,	string org_name, vector<string> chrs){
    vector< pair <datanew,bedann> > datasets;
    string strands[2]={"+","-"};
    bool restart_write=true;
    for (unsigned int st=0;st<2;st++){
        restart_write=true;
        for (unsigned int ch=0;ch<chrs.size();ch++){

            datanew DATA(folder_data_param,	org_name, strands[st], chrs[ch], 0);
            DATA.read_counts();
            DATA.read_sequence();
            bedann ORF=get_orfs(DATA,restart_write);restart_write=false;
            datasets.push_back(make_pair(DATA,ORF));
        }
    }
    return datasets;
}
///*&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&*////
/// This function computes the isolated reads
vector <unsigned int> get_isolated(vector< pair <datanew,bedann> > datasets){

    unsigned int WINDOW=400;
    vector <unsigned int> counts0;
    map< pair<float,unsigned int>,pair<string, unsigned int> > countstemp;
    map< pair<float,unsigned int>,pair<string, unsigned int> >::iterator it;

    for (unsigned int itdata=0;itdata<datasets.size();itdata++){
        datanew DATA=datasets[itdata].first;
        float* countsm=new float[DATA.T];
        sliding_window_exclpoz(DATA.counts,DATA.T, WINDOW, countsm);
        for (unsigned int i=1;i<DATA.T;i++) {
             if(countsm[i]<=0.01&&DATA.counts[i]>0) {
                 countstemp[make_pair(countsm[i],i)]=make_pair(string(DATA.crom+"\t"+DATA.strand), DATA.counts[i]);}
        }
    }

    ofstream file;
    file.open((datasets[0].first.counts_folder+"isolated_counts.wig").c_str());

    unsigned int tt=0;
    for (it=countstemp.begin(); it!=countstemp.end();it++){
        counts0.push_back((it->second).second);
        file<<(it->second).first<<"\t"<<(it->first).second<<"\t"<<(it->second).second<<"\t"<<(it->first).first<<endl;
        tt++;
        if(tt>=2000) break;
    }
    file.close();
    return counts0;
}

///*&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&*////
/// This function computes the histogram for the isolated reads

void R2_isolated_obs( map< unsigned int, unsigned int> *phistcounts0,vector <unsigned int>counts0){

    map< unsigned int, unsigned int> histcounts0;

    for ( unsigned int i=0;i<counts0.size();i++){
        histcounts0[counts0[i]]++;
//        total=total+1;
    }
    int maxcount=(histcounts0.end())->first;
    for (int t=1; t<=maxcount;t++){         histcounts0[t]+=0;}

    *phistcounts0=histcounts0;
}

///*&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&*////
/// This function computes the R2 for the isolated reads

double R2_isolated_obs_est(map< unsigned int, unsigned int> histcounts0,float a,float kappa,float ks,float p1, float alphas){

    double r2=0,sum_obs=0,obs_square=0,obs_est=0,est,obs,total=0;
    map< unsigned int, unsigned int> ::iterator it;
    for (it=histcounts0.begin(); it!=histcounts0.end();it++){
        total=total+it->second;
    }
    for (it=histcounts0.begin(); it!=histcounts0.end();it++){
        obs=it->second/total;
        est=(1-p1)*gsl_ran_negative_binomial_pdf(it->first,1/(a*kappa+1),1/kappa)/(1-pow(1/(a*kappa+1),(1/kappa)));

        if((it->first)==1) est=est+p1;
        obs_est=obs_est+pow(obs-est,2);
        obs_square=obs_square+pow(obs,2);
        sum_obs=sum_obs+obs;

    }

    r2=obs_est/(obs_square-pow(sum_obs,2)/histcounts0.size());
    return r2;
}


///*&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&*////
/// This function computes the observed values for ORFs: var, zero counts and acf

void R2_zerocounts_variance_acf_obs(vector< pair< pair<unsigned int,double>,pair<float, float> > > *pacf,vector< pair<float,pair<float,float> > > *pmean_var_zero,
                                             vector< pair <datanew,bedann> > datasets){
    float  meanlimit=0.1;
    unsigned int maxlag=10;
    vector<pair<float,pair<float,float> > > temp_mean_var_zero;
    vector<pair<pair<unsigned int,double>,pair<float, float> > > acf; // lag,acg,mean,var

    unsigned int length;
    float mean, var, zero,ac;

/** for each dataset compute mean, var, acf and put this in two vectors mean_var_zero and acf ; filter by expression and length (for acf only) **/
    for (unsigned int itdata=0;itdata<datasets.size();itdata++){

        datanew DATA=datasets[itdata].first;
        bedann ORF=datasets[itdata].second;
        if(DATA.strand=="+"){

            unsigned int lastpoz=(*(DATA.poz_counts.end()-1)).second.first;
            unsigned int i=0, j=0;

            for(i=0;i<ORF.size();i++){
                mean=0; var=0; zero=0;
                while((DATA.poz_counts[j].second.first>=ORF[i].first.second)&&j>0) { j--;} /// if the counts position is after the orf start reset the counts serching before the orf start
                while((DATA.poz_counts[j].second.first<ORF[i].first.second) &&(DATA.poz_counts[j].second.first<lastpoz)) { j++;                }
                while((DATA.poz_counts[j].second.first<=ORF[i].second.first)&&(DATA.poz_counts[j].second.first<lastpoz)) {
                    mean+=DATA.poz_counts[j].second.second;
                    var+=pow((float)DATA.poz_counts[j].second.second,2);
                    zero+=1;
                    j++;
                }

                length=ORF[i].second.first -ORF[i].first.second+1;
                mean=mean/length;   var=var/length-pow(mean,2);   zero=1-zero/length;
                if(mean>meanlimit&& var>0.01) {temp_mean_var_zero.push_back(make_pair(mean,make_pair(var,zero)));}

                int* counts_ORF;          counts_ORF=new int[length];
                for(unsigned int ii=0;ii<length;ii++){counts_ORF[ii]=DATA.counts[ii+ORF[i].first.second];}

                if(length>200&&length<2000&&mean>meanlimit) {
                    for (unsigned int lag=1;lag<=maxlag;lag++){
                        ac=0;
                        for(unsigned int ii=0;ii<length-lag;ii++)
                        ac+=(counts_ORF[ii]-mean)*(counts_ORF[ii+lag]-mean)/(var*length);
                        acf.push_back(make_pair(make_pair(lag,ac),make_pair(mean,var)));
                    }
                }
            }
        }

        if(DATA.strand=="-"){

            unsigned int lastpoz=DATA.poz_counts.size();// coutsize=DATA.poz_counts.size();
            unsigned int i=0, j=DATA.poz_counts.size();

            for(i=0;i<ORF.size();i++){
                mean=0; var=0; zero=0;

                while(DATA.poz_counts[j].second.first>ORF[i].first.second&&j<lastpoz) { j++;}
                while((DATA.poz_counts[j].second.first<ORF[i].first.second) &&(j>0)) { j--;                }
                while((DATA.poz_counts[j].second.first<=ORF[i].second.first)&&(j>0)) {
                    mean+=DATA.poz_counts[j].second.second;
                    var+=pow((float)DATA.poz_counts[j].second.second,2);
                    zero+=1;
                    j--;
                }

                length=ORF[i].second.first -ORF[i].first.second+1;
                mean=mean/length;   var=var/length-pow(mean,2);   zero=1-zero/length;
                if(mean>meanlimit&&var>0.01) temp_mean_var_zero.push_back(make_pair(mean,make_pair(var,zero)));

                int* counts_ORF;          counts_ORF=new int[length];
                for(unsigned int ii=0;ii<length;ii++){ counts_ORF[ii]=DATA.counts[ii+ORF[i].first.second];}

                if(length>200&&length<2000&&mean>meanlimit) {
                    for (unsigned int lag=1;lag<=maxlag;lag++){
                        ac=0;
                        for(unsigned int ii=0;ii<length-lag;ii++)
                        ac+=(counts_ORF[ii]-mean)*(counts_ORF[ii+lag]-mean)/(var*length);
                        acf.push_back(make_pair(make_pair(lag,ac),make_pair(mean,var)));

                    }
                }
            }
        }
    }
    *pacf=acf;
    *pmean_var_zero=temp_mean_var_zero;
}

///*&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&*////
/// This function computes the R2 for ORFs: var, zero counts and acf
double R2_variance_obs_est(vector<pair<float,pair<float,float> > > mean_var_zero, float a,float kappa,float ks,float p1, float alphas){


    double r2_var=0;
/// for variance
    double sum_obs=0,obs_square=0,obs_est=0,est,obs;
    for (unsigned int p=0;p<mean_var_zero.size();p++){

        est=log((kappa+ks+kappa*ks)*pow(mean_var_zero[p].first,2)+mean_var_zero[p].first*(1+a+kappa*a));
        obs=log(mean_var_zero[p].second.first);
        obs_est=obs_est+pow(obs-est,2);
        obs_square=obs_square+pow(obs,2);
        sum_obs=sum_obs+obs;

    }

    r2_var=obs_est/(obs_square-pow(sum_obs,2)/mean_var_zero.size());

    return r2_var;
}


///*&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&*////
/// This function computes the R2 for ORFs: var, zero counts and acf
double R2_zerocounts_obs_est(vector<pair<float,pair<float,float> > > mean_var_zero, float a,float kappa,float ks,float p1, float alphas){

    double r2_zero=0;
///for zero counts
    double sum_obs=0,obs_square=0,obs_est=0,est,obs;
    unsigned int xmax=300;
    float curr, prev;
    int jump=5;
    for (unsigned int p=0;p<mean_var_zero.size();p++){
        est=gsl_ran_negative_binomial_pdf(0,a/(ks*mean_var_zero[p].first+a),1/ks);


        for(unsigned int x=1;x<=30;x++) {
            curr=gsl_ran_negative_binomial_pdf(x,a/(ks*mean_var_zero[p].first+a),1/ks)*gsl_ran_negative_binomial_pdf(0,1/(x*a*kappa+1),1/kappa);
            est+=curr;
            prev=curr;
        }
/// here compute only 1 in 5 and estimate between
        for(unsigned int x=(30+jump);x<xmax;x+=jump) {
            curr=gsl_ran_negative_binomial_pdf(x,ks*a/(ks*a+mean_var_zero[p].first),ks)*gsl_ran_negative_binomial_pdf(0,1/(x*a*kappa+1),1/kappa);
            for (int i=1; i<=jump; i++){
                est+=curr*(float)i/jump+prev*(1-(float)i/jump);
            }
            prev=curr;
        }

        obs=mean_var_zero[p].second.second;
        obs_est=obs_est+pow(obs-est,2);
        obs_square=obs_square+pow(obs,2);
        sum_obs=sum_obs+obs;
    }
    r2_zero=obs_est/(obs_square-pow(sum_obs,2)/mean_var_zero.size());

    return r2_zero;
}


///*&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&*////
/// This function computes the R2 for ORFs:  acf
double R2_acf_obs_est(vector<pair<pair<unsigned int,double>,pair<float, float> > > acf, float a,float kappa,float ks,float p1, float alphas){

    double r2_acf=0;
    unsigned int maxlag=10;
    float number_obs=acf.size()/maxlag;

    double sum_obs=0,obs_square=0,obs_est=0,est,obs;

    float *estlag=new float[maxlag+1]; for (unsigned int ilag=0;ilag<=maxlag;ilag++) estlag[ilag]=0;
    float *obslag=new float[maxlag+1]; for (unsigned int ilag=0;ilag<=maxlag;ilag++) obslag[ilag]=0;

    for (unsigned int p=0; p<acf.size();p++){

        estlag[acf[p].first.first]+=pow(acf[p].second.first,2)*ks/acf[p].second.second*pow(alphas,acf[p].first.first);
        obslag[acf[p].first.first]+=acf[p].first.second;

    }

    for (unsigned int lag=1; lag<=maxlag;lag++){
        obs=pow(obslag[lag]/number_obs,1.0/lag);
        est=pow(estlag[lag]/number_obs,1.0/lag);


        obs_est=obs_est+pow(obs-est,2);
        obs_square=obs_square+pow(obs,2);
        sum_obs=sum_obs+obs;
    }
    r2_acf=obs_est/(obs_square-pow(sum_obs,2)/maxlag);

    return r2_acf;
}


///*&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&*////
/// This function computes estimates the parameters that minimize the R2 sum: izolated,  var, zero counts and acf

map< double,struct_param > get_best_param(vector<pair<pair<unsigned int,double>,pair<float, float> > > acf, vector<pair<float,pair<float,float> > > mean_var_zero,
                      map< unsigned int, unsigned int> histcounts0){

    cout<<"Start optimizing parameters"<<endl;
    float a=0.5,kappa=0.5,ks=0.5, p1=0,alphas=0.5;

    double r2;
    float r2var,r2zero,r2iso,r2acf;

    map< double,struct_param >rez;
    map< double,struct_param >rezacf;
    map< double,struct_param >rezfin;
    map< double,struct_param >::iterator itrez;

    /// first select 1000 values for (a,kappa, ks) that minimize the variance
    //int iteration=0;int N=100;
    int NN=14;
    float *values; values=new float[NN];
    int j=0;
    float i;
    for( i=-6; i<-2;i+=1.15){values[j]=pow(2,i); j++; }
    while(j<NN){    i+=0.45; values[j]=pow(2,i); j++;  }
    float alphasval[7]={0.4,0.5,0.6,0.7,0.8,0.85,0.92};
    float p1val[5]={0,0.05,0.1,0.15,0.25};


///*******************************************************************************************************************************************************///
///**/// get r2 for the NB
    float ksnb=0,alphasnb=0;
    double tempnb;
    for (unsigned int inb=0;inb<mean_var_zero.size();inb++)
        ksnb+=(mean_var_zero[inb].second.first-mean_var_zero[inb].first)/pow(mean_var_zero[inb].first,2);
    ksnb=ksnb/mean_var_zero.size();

    for (unsigned int inb=0;inb<acf.size();inb++){
        tempnb=(acf[inb].first.second*acf[inb].second.second)/(acf[inb].second.first*ksnb);
        tempnb=tempnb<0?0:tempnb;
        alphasnb+=pow(tempnb,1.0/acf[inb].first.first);
    }
    alphasnb=alphasnb/acf.size();

    float r2nbvar=R2_variance_obs_est(  mean_var_zero,0.01, 0.01, ksnb, 1, alphasnb);r2nbvar=r2nbvar>1?1:r2nbvar;
    float r2nbzero=R2_zerocounts_obs_est( mean_var_zero,0.01, 0.01, ksnb, 1, alphasnb); r2nbzero=r2nbzero>1?1:r2nbzero;
    float r2nbiso=R2_isolated_obs_est( histcounts0,0.01, 0.01, ksnb, 1, alphasnb); r2nbiso=r2nbiso>1?1:r2nbiso;
    float r2nbacf=R2_acf_obs_est( acf,0.01, 0.01, ksnb, 1, alphasnb); r2nbacf=r2nbacf>1?1:r2nbacf;
    struct_param  paramnb={{0.01,0.01,ks,0.01,alphasnb,r2nbvar,r2nbzero,r2nbiso,r2nbacf}};
    rez[r2nbvar+r2nbzero+r2nbiso+r2nbacf]=paramnb;

    cout<<"R-square for Negative binomial parametrization of estimated overdispersion "<<ksnb<<" and without local bais: "<<r2nbvar+r2nbzero+r2nbiso+r2nbacf<<endl;
///*******************************************************************************************************************************************************///
///**/// explore

    for(j=0;j<NN;j++){
        cout<<"Done "<<floor(100*j/(float)NN)<<"% \t";
        for(int jj=0;jj<NN;jj++){
            for(int jjj=0;jjj<NN;jjj++){
                a=values[j];kappa=values[jj];ks=values[jjj];
                r2var=R2_variance_obs_est(  mean_var_zero,a, kappa, ks, p1, alphas);    if (r2var> paramnb.val[5]) continue;
                r2zero=R2_zerocounts_obs_est(  mean_var_zero,a, kappa, ks, p1, alphas); if (r2zero> paramnb.val[6]) continue;
                for(int jjjj=0;jjjj<6;jjjj++){
                    p1=p1val[jjjj];
                    r2iso=R2_isolated_obs_est(histcounts0,a, kappa, ks, p1, alphas);   if (r2iso>paramnb.val[7]) continue;
                    for(int jjjjj=0;jjjjj<8;jjjjj++){
                        alphas=alphasval[jjjjj];
                        r2acf=R2_acf_obs_est(acf,a, kappa, ks, p1, alphas);    if (r2acf>paramnb.val[8]) continue;
                        struct_param param={{a,kappa,ks,p1,alphas,r2var,r2zero,r2iso,r2acf}};
                        r2=r2var+r2zero+r2iso+r2acf;
                        rez[r2]=param;
                    }
                }
            }
        }
        cout<<"Parameter sample size: "<<rez.size()<< endl;
    }

//cout<<"rez size at the end: "<<rez.size();
     return rez;
 }

///*&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&*////
/// This function reads model parameters from Parameters_initial. If this file doesn't exist it computes the isolated and ORF relaterd indicators and
/// runs the optimisation function. It writes the Parameters_initial file

void read_model_parameters(string folder_data_param,string org_name, string file_parsmodel,	double* param, bool* ind_param, unsigned int npars){
	// 0-alfa, 1-beta0,2- beta,3- gammau,4- gammad,5- 1-eta,6- eta,7- lambdau, 8-lambdad, 9- psi, 10 -zeta, 11,12,13- epsilon,epsilon2,ephi2

	ifstream file0;
	file0.open((folder_data_param+"/counts/"+file_parsmodel).c_str());
	if(file0.good()){
		cout<<"Reading initial "<<npars<<" parameters from: "<< (folder_data_param+"/counts/"+file_parsmodel).c_str()<<endl;
		string dummy;
		for(unsigned int parit=0; parit<npars;parit++){
			file0>>dummy; file0>>param[parit];file0>>ind_param[parit];}
		file0.close();
	}
	else{
	    cout<<" Emission parameters not estimated. Estimating them now."<<endl;

	    vector<string> chrs=get_chromosomes(string(folder_data_param+"/counts/"),org_name,"no");
        vector< pair <datanew,bedann> > datasets=get_datasets(folder_data_param,	org_name,chrs);
        vector <unsigned int>counts0=get_isolated(datasets);
        map< unsigned int, unsigned int> histcounts0;
        vector<pair<pair<unsigned int,double>,pair<float, float> > > acf;
        vector<pair<float,pair<float,float> > > mean_var_zero;

        R2_isolated_obs( &histcounts0,counts0);
        R2_zerocounts_variance_acf_obs(&acf,&mean_var_zero, datasets);

        map< double,struct_param > emis_param=get_best_param(acf, mean_var_zero, histcounts0);
        map< double,struct_param >::iterator itemis_param;
        struct_param emis_best=emis_param.begin()->second;

        ofstream file0;
        file0.open((folder_data_param+"/counts/emission_parameter_sample").c_str());
        if(file0){
            file0<<"a"<<"\t"<<"kappa"<<"\t"<<"ks"<<"\t"<<"p1"<<"\t"<<"alphas"<<"\t"<<"r2var"<<"\t"<<"r2zero"<<"\t"<<"r2iso"<<"\t"<<"r2acf"<<"\t"<<"r2"<<endl;
            for ( itemis_param=emis_param.begin();itemis_param!=emis_param.end();itemis_param++){
                for (int i=0;i<9;i++)
                    file0<<itemis_param->second.val[i]<<"\t";
                file0<<itemis_param->first<<endl;
            }
        }
		file0.close();

		char** name_param= new char*[18];
		cout<<"Setting default initial parameters for expression transition.\n"<<endl;
		name_param[0]=strdup("alpha"); param[0]=0.98; ind_param[0]=1;
		name_param[1]=strdup("beta0"); param[1]=0.001; ind_param[1]=1;
		name_param[2]=strdup("beta"); param[2]=0.001; ind_param[2]=1;
		name_param[3]=strdup("gamma_u"); param[3]=0.002; ind_param[3]=1;
		name_param[4]=strdup("gamma_d"); param[4]=0.002; ind_param[4]=1;
		name_param[5]=strdup("1meta"); param[5]=0.999; ind_param[5]=1;
		name_param[6]=strdup("eta"); param[6]=0.001; ind_param[6]=1;
		name_param[7]=strdup("lam_u"); param[7]=5; ind_param[7]=0;
		name_param[8]=strdup("lam_d"); param[8]=5; ind_param[8]=0;
		name_param[9]=strdup("not_used"); param[9]=1; ind_param[9]=0;
		name_param[10]=strdup("zeta"); param[10]=1; ind_param[10]=1;
		name_param[11]=strdup("epsi"); param[11]=0.001; ind_param[11]=1;
		name_param[12]=strdup("epsi2"); param[12]=0.0001; ind_param[12]=1;
		name_param[13]=strdup("ymax"); param[13]=1000; ind_param[13]=1;
		name_param[14]=strdup("not_used"); param[14]=0; ind_param[14]=0;
		name_param[15]=strdup("alpha_s"); param[15]=floor(emis_best.val[4]*100+0.5)/100.0; ind_param[15]=0;/// here parameters are estimated
		name_param[16]=strdup("kappa_s"); param[16]=floor(emis_best.val[2]*100+0.5)/100.0; ind_param[16]=0;/// here parameters are estimated
        name_param[17]=strdup("kappa"); param[17]=floor(emis_best.val[1]*100+0.5)/100.0;  ind_param[17]=0;/// here parameters are estimated
		name_param[18]=strdup("a"); param[18]=floor(emis_best.val[0]*100+0.5)/100.0;ind_param[18]=0;/// here parameters are estimated


        file0.open((folder_data_param+"/counts/"+file_parsmodel).c_str());
        if(file0){
            for(unsigned int parit=0; parit<npars;parit++){
                file0<<name_param[parit]<<"\t"<< param[parit]<<"\t"<< ind_param[parit]<<endl;
            }
        }
		file0.close();
    }
}


string* read_algorithm_parameters(string folder_data_param, string file_parsalg,string* names,double * parameters_alg, unsigned int npars_alg){
	//		string name_org, string name_strand, string name_chr,	string SMC_type, string alg_type, string iter_name

	ifstream file0;
	file0.open((folder_data_param+file_parsalg).c_str());
	string dummy; 	getline(file0,dummy);
	for (unsigned int parit=0;parit<npars_alg; parit++){file0>>parameters_alg[parit];}
	char tname[4];
	file0>>tname;	names[0]=string(tname);//name_org
	file0>>tname;	names[1]=string(tname); //strand
	file0>>tname;	names[2]=string(tname);//name_chr
	char tSMC_type[6];	file0>>tSMC_type;	names[3]=string(tSMC_type);//SMC_type
	char ttype[3];	file0>>ttype;	names[4]=string(ttype);//alg_type
	char titername[1000]; file0>>titername;	 names[5]=string(titername);//iter_name
	file0.close();
	return names;
}


void read_algorithm_parameters_new(string folder_pars, string file_pars,	double* param, unsigned int nparsalg){
	cout<< "Read algorithm parameters from: "<<(folder_pars+"/"+file_pars).c_str()<<endl;
	cout<<endl<< "Parseq is using the following parameters: "<<endl;
	ifstream file0;
	file0.open((folder_pars+"/"+file_pars).c_str());
	if(!file0){
	cout<<"The file Parameters_parseq is missing or is not in the correct folder:"<<folder_pars<<endl;exit(2);}
	string dummy;
	for(unsigned int parit=0; parit<nparsalg;parit++){
		file0>>dummy; file0>>param[parit]; cout<< dummy<<" "<<param[parit]<<endl;}
	file0.close();
	cout<<endl;
}
//////////////////////////////** **//////////////////////////////////////////////////////////////////////////////////////////////////////////////////

vector<string> get_chromosomes(string counts_folder,string org_name,string partial){
    unsigned int length; string chr;
    vector<string> chrs;

/**get chromosomes from chrom.sizes**/

	ifstream  file;
	file.open((counts_folder+org_name+".chrom.sizes").c_str());
	if(!file) {cerr<<"MISSING INPUT!!! \t I was looking for: "<<(counts_folder+org_name+".chrom.sizes").c_str()<<".\n Probably the counts folder is wrong."<< endl; exit(1);}

	while ((file >> chr>>length).good()){

		if(partial=="yes")
            if(chr.find("_part_")<=chr.length())
                chrs.push_back(chr);
  		if(partial=="no")
            if(chr.find("_part_")>chr.length())
                chrs.push_back(chr);
	}
	file.close();

    cout<<"The following chromosomes were found in the .chrom.sizes file:"<<endl;
    for (unsigned int ch=0;ch<chrs.size();ch++){
        cout<<"crom: "<<chrs[ch]<<endl;
    }
    cout<<endl;

	return chrs;

};
