#ifndef DEF_PARAM_H
#define DEF_PARAM_H

//# include <iostream>
//# include <fstream>
//# include <stdio.h>
//# include <string.h>
//#include <vector>
//#include <utility>
//#include <math.h>
////#include <gsl/gsl_statistics_int.h>
//#include <gsl/gsl_multifit.h>
//#include <gsl/gsl_multifit_nlin.h>
//#include <gsl/gsl_fit.h>
//#include <gsl/gsl_min.h>

#include "data.h"

using namespace std;


typedef vector < pair<pair<string,unsigned int>,pair<unsigned ,char> > > bedann;// crom, start,stop,strand
typedef struct emis_param{
    float val[9]; /// first 5 parameters; folowing 4 r2 values for var, zero, isolated and acf

} struct_param;
bedann get_orfs(datanew DATA, bool restart_write);

vector< pair <datanew,bedann> >  get_datasets(string folder_data_param,	string org_name, vector<string> chrs);
vector <unsigned int> get_isolated(vector< pair <datanew,bedann> > datasets);

void R2_isolated_obs( map< unsigned int, unsigned int> *histcounts0,vector <unsigned int>counts0);
double R2_isolated_obs_est(map< unsigned int, unsigned int> histcounts0,float a,float kappa,float ks,float p1, float alphas);

void R2_zerocounts_variance_acf_obs(vector<pair<pair<unsigned int,double>,pair<float, float> > > *pacf,vector<pair<float,pair<float,float> > > *pmean_var_zero,
                                             vector< pair <datanew,bedann> > datasets);
double R2_variance_obs_est(vector<pair<float,pair<float,float> > > mean_var_zero,float a,float kappa,float ks,float p1, float alphas);
double R2_zerocounts_obs_est(vector<pair<float,pair<float,float> > > mean_var_zero,float a,float kappa,float ks,float p1, float alphas);
double R2_acf_obs_est(vector<pair<pair<unsigned int,double>,pair<float, float> > > acf, float a,float kappa,float ks,float p1, float alphas);
map< double,struct_param > get_best_param(vector<pair<pair<unsigned int,double>,pair<float, float> > > acf, vector<pair<float,pair<float,float> > > mean_var_zero,
                      map< unsigned int, unsigned int> histcounts0);

vector<string> get_chromosomes(string counts_folder,string org_name,string partial);
void read_algorithm_parameters_new(string folder_pars, string file_pars,	double* param, unsigned int nparsalg);
void read_model_parameters(string folder_data_param, string org_name, string file_parsmodel, 	double* param, bool* ind_param,  unsigned int npars);


void get_amplification(string counts_folder,string org_name,float* kappa,float* theta); //crom, strand,poz,counts
void get_overdispersion(string counts_folder,string name_org,float kappa, float theta, float* kappa_s, float* alpha_s);
float difvar(float ks,float mean,float var,float kappa,float theta );// fit the variance
float difzero(float ks,float mean,float zero,float kappa,float theta );

#endif

