#include "functions.h"



int indicator(double a,double b, double y){	if ((a<=y)&(b>=y)) return 1;	else return 0;}

double sum_vec(double* a, int n){	double sum=0;	for(int i=0;i<n;i++){	sum=sum+a[i];	}	return sum;}

double sum_vec(int* a, int n){	double sum=0;	for(int i=0;i<n;i++){		sum=sum+(double)a[i];	}	return sum;}

double* divide_vec(double* a, int n, double k){	for(int i=0;i<n;i++){
	a[i]=a[i]/k;	}	return a;}

void divide_vec_new(double* b, double* a, int n, double k){	for(int i=0;i<n;i++){b[i]=a[i]/k;}}

void normalize_vec (double* a, int n, double k){
	k=0; for(int i=0;i<n;i++){k=k+a[i];}
	for(int i=0;i<n;i++){a[i]=a[i]/k;}
}
void sample_multinom ( gsl_rng* rgen, int* sample, int size_sample, int* x, double* p, int size_vec){
	if (size_vec==1) { sample[0]=x[0]; return ;}

	p=divide_vec(p, size_vec, sum_vec(p,size_vec));
	double* random;
	random= new double[size_sample+1];
	for (int i=0; i<(size_sample+1);i++){random[i]=gsl_ran_exponential(rgen,1);}
	double temp;
	//	cout<<"temp: "<<temp<<endl;
	temp=sum_vec(random,(size_sample+1));
	random[0]=random[0]/temp;
	for (int i=1; i<size_sample;i++){random[i]=random[i]/temp+random[i-1];}
	temp=0;
	int j=0;
	for (int i=0;i<size_sample;i++){
		while ((random[i]>temp) &( j<size_vec)){
			temp=temp+p[j];
			j=j+1;
		}
		sample[i]=x[j-1];
	}
	delete []random;
}

void sample_multinom_NEW ( gsl_rng* rgen, int* sample, int size_sample, int* x, double* p, int size_vec){

    double psum=sum_vec(p,size_vec);
    if(abs(psum-1)>0.0000001){ for (int i=0; i<size_vec;i++){ p[i]= p[i]/psum; }}


	double* random;
	random= new double[size_sample+1];
	for (int i=0; i<(size_sample+1);i++){random[i]=gsl_ran_exponential(rgen,1);}
	double temp;
	//	cout<<"temp: "<<temp<<endl;
	temp=sum_vec(random,(size_sample+1));
	random[0]=random[0]/temp;
	for (int i=1; i<size_sample;i++){random[i]=random[i]/temp+random[i-1];}
	temp=0;
	int j=0;
	for (int i=0;i<size_sample;i++){
		while ((random[i]>temp) &( j<size_vec)){
			temp=temp+p[j];
			j=j+1;
		}
		sample[i]=x[j-1];
	}
	delete []random;
}

void sample_multinom_indices ( gsl_rng* rgen, int* sample, int size_sample, double* p, int size_vec){

    double psum=sum_vec(p,size_vec);
    if(abs(psum-1)>0.0000001){ for (int i=0; i<size_vec;i++){ p[i]= p[i]/psum; }}

	double* random;
	random= new double[size_sample+1];
	for (int i=0; i<(size_sample+1);i++){random[i]=gsl_ran_exponential(rgen,1);}
	double temp;
	//	cout<<"temp: "<<temp<<endl;
	temp=sum_vec(random,(size_sample+1));
	random[0]=random[0]/temp;
	for (int i=1; i<size_sample;i++){random[i]=random[i]/temp+random[i-1];}
	temp=0;
	int j=0;
	for (int i=0;i<size_sample;i++){
		while ((random[i]>temp) &( j<size_vec)){
			temp=temp+p[j];
			j=j+1;
		}
		sample[i]=j-1;
	}
	delete []random;
}


void sample_multinom ( gsl_rng* rgen, int* sample, int size_sample, int* x, int size_vec){
	if (size_vec==1) { sample[0]=x[0]; return ;}

	double* random;
	random= new double[size_sample+1];
	for (int i=0; i<(size_sample+1);i++){random[i]=gsl_ran_exponential(rgen,1);}
	double temp;
	temp=sum_vec(random,(size_sample+1));
	random[0]=random[0]/temp;
	for (int i=1; i<(size_sample+1);i++){random[i]=random[i]/temp+random[i-1];}
	temp=0;
	int j=0;
	for (int i=0;i<size_sample;i++){
		while ((random[i]>temp) &( j<size_vec)){
			temp=temp+(double)1/size_vec;
			j=j+1;
		}
		sample[i]=x[j-1];
	}

	delete []random;
}


void sample_multinom ( gsl_rng* rgen, double* sample, int size_sample, double* x, double* p, int size_vec){
	if (size_vec==1) { sample[0]=x[0]; return ;}

	p=divide_vec(p, size_vec, sum_vec(p,size_vec));
	double* random;
	random= new double[size_sample+1];
	for (int i=0; i<(size_sample+1);i++){random[i]=gsl_ran_exponential(rgen,1);}
	double temp;
	temp=sum_vec(random,(size_sample+1));
	random[0]=random[0]/temp;
	for (int i=1; i<(size_sample+1);i++){random[i]=random[i]/temp+random[i-1];}
	temp=0;
	int j=0;
	for (int i=0;i<size_sample;i++){
		while ((random[i]>temp) & (j<size_vec)){
			temp=temp+p[j];
			j=j+1;
		}
		sample[i]=x[j-1];
	}
	delete []random;
}



int sample_multinom_one ( gsl_rng* rgen, int* x, double* p, int size_vec){
	int sample=x[0];
	if (size_vec==1) {return sample;}
	else{
		p=divide_vec(p, size_vec, sum_vec(p,size_vec));
		double random=gsl_rng_uniform (rgen);
		double temp=0;
		for(int i=0;i<size_vec;i++){
			temp=temp+p[i];
			if(	random<temp) {sample=x[i]; break;}
		}
	}
	return sample;
}



int sample_multinom_one_indices ( gsl_rng* rgen, int* x, double* p, int size_vec){
	int sample=x[0];
	if (size_vec==1) {return sample;}
	else{
		p=divide_vec(p, size_vec, sum_vec(p,size_vec));
		double random=gsl_rng_uniform (rgen);
		//		cout<<"random sampl: "<<random<<" -- ";
		double temp=0;
		for(int i=0;i<size_vec;i++){
			temp=temp+p[i];
			if(	random<temp) {sample=i; break;}
		}
	}
	return sample;
}


double sample_multinom_one ( gsl_rng* rgen, double* x, double* p, int size_vec){
	double sample=x[0];
	if (size_vec==1) {return sample;}
	else{
		p=divide_vec(p, size_vec, sum_vec(p,size_vec));
		double random=gsl_rng_uniform (rgen);
		double temp=0;
		for(int i=0;i<size_vec;i++){
			temp=temp+p[i];
			if(	random<temp) {sample=x[i];break;}
		}
	}
	return sample;
}

double sample_multinom_one_indices ( gsl_rng* rgen, double* x, double* p, int size_vec){
	double sample=x[0];
	if (size_vec==1) {return sample;}
	else{
		p=divide_vec(p, size_vec, sum_vec(p,size_vec));
		double random=gsl_rng_uniform (rgen);
		double temp=0;
		for(int i=0;i<size_vec;i++){
			temp=temp+p[i];
			if(	random<temp) {sample=i;break;}
		}
	}
	return sample;
}




double evaluate_model(double* st,double* xt,int n,string type){
	double sum=0;
	if (type=="mean difference"){
		for (int i=0;i<n;i++){
			sum=sum+pow((st-xt),2.00);
		}
	}

	if (type=="percentage correct"){
		for (int i=0;i<n;i++){
			if(((-0.1*st[i])<(st[i]-xt[i])) & ((st[i]-xt[i])<(0.1*st[i]))){sum++;}
		}
		sum=sum/n;
	}

	if (type=="segment comparison"){
		for (int i=0;i<n;i++){
			if(((-0.1*st[i])<(st[i]-xt[i])) & ((st[i]-xt[i])<(0.1*st[i]))){sum++;}
		}
		sum=sum/n;
	}

	return sum;
}

int get_breakpoints(int* brk, double* xt,int n){

	int k=0;
	vector<int>vbrk;
	for(int i=0;i<n-1;i++){
		if(xt[i]!=xt[i+1]){ vbrk.push_back(i+1); k++;}
	}
	for(int i=0;i<k;i++){
		brk[i]=vbrk[i];
	}
	return k;
}


void write_vec (double* x, int T, string folder, string a,   ofstream & file1){
	a=folder+a;
	file1.open(a.c_str());
	for(int i=0; i<T; i++){file1<<x[i]<<" ";}
	file1.close();
}
void write_vec (int* x, int T, string folder, string a,   ofstream & file1){

	a=folder+a;
	file1.open(a.c_str());
	for(int i=0; i<T; i++){file1<<x[i]<<" ";}
	file1.close();
}

void write_vec_column (int* x, int T, string folder, string a,   ofstream & file1){

	a=folder+a;
	file1.open(a.c_str());
	for(int i=0; i<T; i++){file1<<x[i]<<endl;}
	file1.close();
}

void write_vec_column (double* x, int T, string folder, string a,   ofstream & file1){

	a=folder+a;
	file1.open(a.c_str());
	for(int i=0; i<T; i++){file1<<x[i]<<endl;}
	file1.close();
}
void write_vec_column_wig (double* x, int T, string folder, string a,string strand, string crom,   ofstream & file1){

	a=folder+a;
	file1.open(a.c_str());
	file1<<string("fixedStep chrom="+crom+" border=1 step=1")<<endl;
	if(strand=="+"){ for(int i=0; i<T; i++){file1<<x[i]<<endl;}}
	else if(strand=="-") {{ for(int i=0; i<T; i++){file1<<x[T-i-1]<<endl;}} }
	else {cerr<<" strand not +/-";}
	file1.close();
}


void append_vec (double* x, int T, string folder, string a,   ofstream & file1,bool restart){

	if(restart) file1.open((folder+a).c_str());
	else file1.open((folder+a).c_str(),ios_base::app);
	if(!file1) cerr<<"NOT able to write/append to "<<(folder+a).c_str()<<endl;
	for(int i=0; i<T; i++){file1<<std::setprecision(4)<<x[i]<<" ";}
	file1<<"\n";
	file1.close();
}
void append_vec (int* x, int T, string folder, string a,   ofstream & file1,bool restart){

    if(restart) file1.open((folder+a).c_str());
	else file1.open((folder+a).c_str(),ios_base::app);

	for(int i=0; i<T; i++){file1<<x[i]<<" ";}
	file1<<"\n";
	file1.close();
}


void append_val(double x, string folder, string a,   ofstream & file1){

	file1.open((folder+a).c_str(),ios_base::app);
	file1<<x<<"\n";
	file1.close();
}


void write_mat (double** x, int T, int N, string folder, string a,   ofstream & file1){
	a=folder+a;
	file1.open(a.c_str());
	for(int i=0;i<N;i++){
		for(int t=0;t<T;t++){	file1<<x[i][t]<<" ";	}
		file1<<endl;
	}
	file1.close();
}
void write_map (map<int,int> wmap, string folder, string a,  ofstream & file1){
	a=folder+a;
	file1.open(a.c_str());
	map<int, int>::iterator it;

	for(it=wmap.begin();it!=wmap.end();it++){
		file1<<(*it).first<<" ";
		file1<<(*it).second<<" ";
		file1<<endl;}
	file1.close();
}


void write_map2 (map<int,int*> wmap, int n, string folder, string a,  ofstream & file1){
	a=folder+a;
	file1.open(a.c_str());
	map<int, int*>::iterator it;

	for(it=wmap.begin();it!=wmap.end();it++){
		file1<<(*it).first<<" ";
		for(int i=0;i<n;i++){ file1<<(*it).second[i]<<" ";	}
		file1<<endl;
	}
	file1.close();
}


void append_map2 (map<int,int*> wmap, int n, string folder, string a,  ofstream & file1){
	a=folder+a;
	file1.open(a.c_str(),ios_base::app);
	map<int, int*>::iterator it;

	for(it=wmap.begin();it!=wmap.end();it++){
		file1<<(*it).first<<" ";
		for(int i=0;i<n;i++){ file1<<(*it).second[i]<<" ";	}
		file1<<endl;
	}
	file1.close();
}



void estimate_moves(int* y,int T, int WINDOW, double * proba_move){
	int hW=(int)WINDOW/2; // half window
	for(int t=0;t<T;t++){ proba_move[t]=0;}
	double* ym= new double[T];
	double* var= new double[T];
	for(int t=0;t<hW;t++){proba_move[t]=0.5;ym[t]=y[t];var[t]=0;}
	for(int t=T-hW;t<T;t++){proba_move[t]=0.5;ym[t]=y[t];var[t]=0;}
	ym[hW]=0;var[hW]=0;
	for(int t=0;t<WINDOW;t++){ym[hW]=ym[hW]+y[t];var[hW]=var[hW]+pow((double)y[t],2); }
	ym[hW]=ym[hW]/WINDOW; var[hW]=var[hW]/WINDOW-pow(ym[hW],2);
	for(int t=hW+1;t<T-hW;t++){
		ym[t]=abs(ym[t-1]+(double)(-y[t-1-hW]+y[t+hW])/WINDOW);
		var[t]=abs(var[t-1]+pow((double)ym[t-1],2)+(-pow((double)y[t-1-hW],2)+pow((double)y[t+hW],2))/WINDOW-pow((double)ym[t],2));
	}

	double t_stat, t_degree;
	for(int t=hW+5;t<T-hW;t++){
		t_stat=(ym[t-hW-1]-ym[t+hW+1])/pow((var[t-hW-1]+var[t+hW+1])/hW+litle,0.5);
		t_degree= (pow(var[t-hW-1]+var[t+hW+1],2)+litle)/((pow(var[t-hW-1],2)+pow(var[t+hW+1],2))/(hW-1)+litle);
		proba_move[t]=2*gsl_cdf_tdist_Q( abs(t_stat),t_degree);
		proba_move[t]=min(1-(1-proba_move[t])/((double)WINDOW/2),0.99);

	}

	delete[] ym; delete [] var;
}


void sliding_window(int* y,int T, int WINDOW, double * ym){
	int hW=(int)WINDOW/2; // half window

	for(int t=0;t<hW;t++){ym[t]=y[t];}
	for(int t=T-hW;t<T;t++){ym[t]=y[t]; }

	for(int t=hW+1;t<T-hW;t++){
		ym[t]=abs(ym[t-1]+(double)(-y[t-1-hW]+y[t+hW])/WINDOW);
	}
}


void sliding_window_exclpoz(int* y,int T, int WINDOW, float * ym){
	int hW=(int)WINDOW/2; // half window
    float temp=0;
	for(int t=0;t<WINDOW;t++){temp+=y[t];}
	temp=temp/WINDOW;
	for(int t=0;t<=hW;t++){ym[t]=temp-(float)y[t]/WINDOW;}
    temp=0;
    for(int t=T-WINDOW;t<T;t++){temp+=y[t];}
	temp=temp/WINDOW;
	for(int t=T-hW;t<T;t++){ym[t]=temp-(float)y[t]/WINDOW;}

	for(int t=hW+1;t<T-hW;t++){
		ym[t]=abs(ym[t-1]+(float)(-y[t-1-hW]+y[t+hW])/WINDOW+(float)(y[t-1]-y[t])/WINDOW);
	}
}


void calculate_likelihood(double* log_likelihood, int Itwrite, string out_folder){


	/// CALCULATE MODEL LIKELIHOOD from likelihood of particles
	// calculate a harmonic average of log_likelihood of last 1/2 particles
	// the log_likelihood is calculated during the PG iterations

	double log_likelihood_estim=0;
	cout.precision(5);
	double base=log_likelihood[Itwrite-1];
	for (int n=(int)Itwrite/2;n<=Itwrite;n++){	log_likelihood_estim=log_likelihood_estim+exp(base-log_likelihood[n]);	}
	log_likelihood_estim=base+log(Itwrite-(int)Itwrite/2)-log(log_likelihood_estim);
	ofstream file_temporar;
	write_vec (log_likelihood, Itwrite, out_folder, "Likelihood",file_temporar);
	file_temporar.close();
}

void calc_sliding_window(int*counts,int T, int sw_window,float *sw){
	sw[0]=0;
	int halfsw=(sw_window-1)/2;
	for ( int t=0; t<sw_window; t++) {sw[0]+=((float)counts[t])/sw_window;}
	for ( int t=0; t<=halfsw; t++) {sw[t]=sw[0];}
	for ( int t=halfsw+1; t<(T-halfsw); t++) {
	    sw[t]=sw[t-1]+((float)counts[t+halfsw]-(float)counts[t-1-halfsw])/sw_window;
	    if(sw[t]<=0) sw[t]=0;}
	for ( int t=(T-sw_window);t<T; t++) {sw[t]=sw[T-sw_window-1];}
}

void calc_sliding_window_count(int*counts,int T, int sw_window,int *sw){
	sw[0]=0;
	int halfsw=(sw_window-1)/2;
	for ( int t=0; t<sw_window; t++) {if(counts[t]>0) sw[0]+=1;}
	for ( int t=0; t<=halfsw; t++) {sw[t]=sw[0];}
	for ( int t=halfsw+1; t<(T-halfsw); t++) {
	    if(counts[t+halfsw]>0) sw[t]=sw[t-1]+1; else sw[t]=sw[t-1];
	    if(counts[t-1-halfsw]>0) sw[t]=sw[t]-1;
	    if(sw[t]<=0) sw[t]=0;
	    }
	for ( int t=(T-sw_window);t<T; t++) {sw[t]=sw[T-sw_window-1];}


}

float loglike_emission(vector<int> counts,float kappa,float theta){
    float llike=0;
    for( unsigned int t=0;t<counts.size();t++){
        llike= llike+log(gsl_ran_negative_binomial_pdf(counts[t],1/(theta+1),kappa))-log(1-1/pow((theta+1),kappa));
    }
    return llike;
}

int compare(const void* elem1, const void* elem2)
{
    if(*(const float*)elem1 > *(const float*)elem2)
        return -1;
    return *(const float*)elem1 < *(const float*)elem2;
}

float* get_cumulative(float* x, int T){
    float* xcum= new float[T];
    xcum[0]=x[0];
    for (int t=1;t<T;t++)
        xcum[t]=xcum[t-1]+x[t];

    return xcum;
}

void calc_localsum_range(int* counts,int window,int *window_range,int T,int** temp){

    int w_temp;
    for ( int t=0;t<T;t++)
        for ( int w=0;w<window;w++)
            {temp[t][w]=0;}

	for ( int w=0;w<window;w++){
        w_temp=window_range[w];

        for ( int t=0; t<w_temp; t++) {
            temp[0][w]=temp[0][w]+counts[t];}
        for ( int t=1; t<(T-w_temp); t++) {
            temp[t][w]=counts[t+w_temp-1]+temp[t-1][w]-counts[t-1];}
        for ( int t=(T-w_temp);t<T; t++) {
            temp[t][w]=temp[T-w_temp][w];}
	}
}

void calc_localsum_range(double* counts,int window,int *window_range,int T,double** temp){

    int w_temp;
    for ( int t=0;t<T;t++)
        for ( int w=0;w<window;w++)
            temp[t][w]=0;

	for ( int w=0;w<window;w++){
        w_temp=window_range[w];

        for ( int t=0; t<w_temp; t++) {
            temp[0][w]=temp[0][w]+counts[t];}
        for ( int t=1; t<(T-w_temp); t++) {
            temp[t][w]=counts[t+w_temp-1]+temp[t-1][w]-counts[t-1];}
        for ( int t=(T-w_temp);t<T; t++) {
            temp[t][w]=temp[T-w_temp][w];}
	}

}

