#ifndef DEF_FUNCTIONS
#define DEF_FUNCTIONS

# include <iostream>
# include <fstream>
# include <sstream>
# include <iomanip>

# include <gsl/gsl_sf.h>
# include <gsl/gsl_randist.h>
# include <gsl/gsl_cdf.h>
//# include <gsl/gsl_statistics_double.h>
//# include <gsl/gsl_fit.h>
//# include <gsl/gsl_multifit.h>
//#include <gsl/gsl_multifit_nlin.h>
//#include <gsl/gsl_math.h>
# include <math.h>
# include <cmath>
# include <vector>
# include <string>
# include <string.h>
# include <map>

#include "model.h"
using namespace std;


# define litle 0.00000000001
# define verylitle 1e-200
# define big 1000000000

//inline int indicator(double x, double y);

inline int indicator(double x, double y){
	double epsilon=abs(x-y);
	if (epsilon<litle) return 1;	else return 0;}

int compare(const void* elem1, const void* elem2);
int indicator(double a, double b, double y);
double sum_vec(double* a, int n);
double sum_vec(int* a, int n);

double* divide_vec(double* a, int n, double k);
void divide_vec_new(double* b, double* a, int n, double k);
void normalize_vec (double* a, int n, double k);


void sample_multinom (gsl_rng* rgen, int* sample, int size_sample, int* x, double* p, int size_vec);
void sample_multinom_NEW (gsl_rng* rgen, int* sample, int size_sample, int* x, double* p, int size_vec);
void sample_multinom_indices ( gsl_rng* rgen, int* sample, int size_sample, double* p, int size_vec);

void sample_multinom (gsl_rng* rgen, int* sample, int size_sample, int* x, int size_vec);
void sample_multinom (gsl_rng* rgen, double* sample, int size_sample, double* x, double* p, int size_vec);
int sample_multinom_one ( gsl_rng* rgen,  int* x, double* p, int size_vec);
double sample_multinom_one ( gsl_rng* rgen,  double* x, double* p, int size_vec);
int sample_multinom_one_indices ( gsl_rng* rgen,  int* x, double* p, int size_vec);
double sample_multinom_one_indices( gsl_rng* rgen,  double* x, double* p, int size_vec);


int get_breakpoints(int* brk, double* xt,int n);

double evaluate_model(double* st,double* xt,int n, string type);

void write_vec (double*x, int T,string folder, string a,  ofstream & file1);
void append_vec (double*x, int T,string folder, string a,  ofstream & file1, bool restart);
void append_vec (int*x, int T,string folder, string a,  ofstream & file1, bool restart);
void append_val(double x, string folder, string a,   ofstream & file1);
void write_vec (int*x, int T, string folder,string a,  ofstream & file1);
void write_mat (double**x, int T, int N, string folder, string a,  ofstream & file1);
void write_map (map<int,int> wmap,  string folder, string a,  ofstream & file1);
void write_map2 (map<int,int*> wmap, int n, string folder, string a,  ofstream & file1);
void write_vec_column (int* x, int T, string folder, string a,   ofstream & file1);
void write_vec_column (double* x, int T, string folder, string a,   ofstream & file1);
void write_vec_column_wig (double* x, int T, string folder, string a,string strand,string crom,   ofstream & file1);


void estimate_moves(int* y,int T, int WINDOW, double* proba_move);
void sliding_window(int* y,int T, int WINDOW, double * ym);
void sliding_window_exclpoz(int* y,int T, int WINDOW, float * ym);

void calculate_likelihood(double* log_likelihood, int Itwrite, string out_folder);
void calc_sliding_window(int*counts, int T, int sw_window,float* sw);
void calc_sliding_window_count(int*counts,int T, int sw_window,int *sw);
float loglike_emission(vector<int> counts,float kappa,float theta);
float* get_cumulative(float* x, int T);
//void calc_localsum_range_float(double* counts,int window_prop,int T,double** temp);
//void calc_localsum_range(int* counts,int window_prop,int T,int** temp);
//void calc_localsum_range(int* counts,int window_max,int window[],int T,double** temp);
void calc_localsum_range(int* counts,int window_max,int *window,int T,int** temp);
void calc_localsum_range(double* counts,int window_max,int *window,int T,double** temp);
#endif
