#include "gibbs_step.h"
bool backward_sampling=true;

void gibbs_step::SMC(gsl_rng* rgen){
//
//	if (SMC_type.compare("Filter") == 0)	{
//		for(unsigned int t=0;t<DATA1.T;t++){	struct_n[t]=1;}
//		filtering (rgen, MODE1,PROP1,DATA1, N);
//		for(unsigned int t=0;t<DATA1.T;t++){	part_n[t]= part_np1[t];}
//		for(unsigned int t=0;t<DATA1.T;t++){	struct_np1[t]=struct_n[t];}
//	}

	if (SMC_type.compare("PG_no_struct") == 0)	{
		for(unsigned int t=0;t<DATA1.T;t++){	struct_n[t]=1;}
		CSMC_part_blocks (rgen, MODE1,PROP1,DATA1, N);
		for(unsigned int t=0;t<DATA1.T;t++){	part_n[t]= part_np1[t];}
		for(unsigned int t=0;t<DATA1.T;t++){	struct_np1[t]=struct_n[t];}
	}

	if (SMC_type.compare("PG_no_part") == 0)	{
		for(unsigned int t=0;t<DATA1.T;t++){	part_n[t]=1;}
		CSMC_struct (rgen, MODE1,PROP1,DATA1, N);
		for(unsigned int t=0;t<DATA1.T;t++){	struct_n[t]= struct_np1[t];}
		for(unsigned int t=0;t<DATA1.T;t++){	part_np1[t]=part_n[t];}
	}

	if (SMC_type.compare("PG_struct") == 0)	{
		CSMC_part_blocks(rgen, MODE1,PROP1,DATA1, N);
		CSMC_struct (rgen, MODE1,PROP1,DATA1, N);
	}

	if (SMC_type.compare("PG_simulate") == 0)	{
		CSMC_part (rgen, MODE1,PROP1,DATA1, N);
		CSMC_struct (rgen, MODE1,PROP1,DATA1, N);
	}

//	if (SMC_type.compare("PG_struct_level") == 0)	{
//        CSMC_part_blocks (rgen, MODE1,PROP1,DATA1, N);
//        CSMC_struct (rgen, MODE1,PROP1,DATA1, N);
//        CSMC_level (rgen, MODE1,PROP1,DATA1, N);
//	}
}

gibbs_step::gibbs_step( string SMC_type, int N, datanew data1, model2	mode, proposal prop){
	this->SMC_type=SMC_type;
	this->DATA1=data1;

	this->MODE1=mode;
	this->PROP1=prop;
	this->N=N;
	w=new double[N];
	itemp_N1= new int[N-1];
	X= new double* [N]; for (int i=0; i<N;i++){X[i]=new double[DATA1.LEN];}
	A= new int* [N]; for (int i=0; i<N;i++){A[i]=new int[DATA1.LEN-1];}
	s_np1= new double* [N]; for (int i=0; i<N;i++){s_np1[i]=new double[DATA1.LEN];}
	w_mat= new float* [N]; for (int i=0; i<N;i++){w_mat[i]=new float[DATA1.LEN];}
	swsum_range= new double* [DATA1.T]; for (unsigned int i=0; i<DATA1.T;i++){swsum_range[i]=new double[PROP1.window];}
	ywsum_range= new int* [DATA1.T]; for (unsigned int i=0; i<DATA1.T;i++){ywsum_range[i]=new int[PROP1.window];}


	part_n=new double[DATA1.T];
	struct_n=new double[DATA1.T];
	part_np1=new double[DATA1.T];
	struct_np1=new double[DATA1.T];;

	bk= new int [DATA1.T];	bkS= new int [DATA1.T]; outlier= new int [DATA1.T];
	z_n= new double[DATA1.T];
	dtemp_T=new double[DATA1.T];
	indices= new int[N]; 	for(int i=0; i<N;i++){ indices[i]=i;}
	sequence_index=new int[DATA1.T-2]; for(int t=0; t<(DATA1.T-2);t++){ sequence_index[t]=t+1;}
	for(unsigned int t=0;t<DATA1.T;t++){ 	poz_update[t].first=0;}
}


void gibbs_step::CSMC_part (gsl_rng * rgen, model2 MODE, proposal PROP, datanew DATA,int N){

	double ESS=0;

/// set the N-1 particle to the  current u^(n) (part_n);
    for(unsigned int t=0;t<=DATA.T;t++){ X[N-1][t]=part_n[t];}
    for(unsigned int t=0;t<DATA.T;t++){ A[N-1][t]=N-1;}

/// compute for t=0;
    PROP.set_y_range(ywsum_range[0],swsum_range[0],DATA.duplicated[0]);
    for(int i=0;i<(N-1);i++){
        X[i][0]=PROP.sample_poz0(rgen);
        w[i] =MODE.emission_proba_struct_duplicated(DATA.counts[0],X[i][0],struct_n[0],DATA.context[0],outlier[0],DATA.duplicated[0])* MODE.kernel_hidden_0(X[i][0]) / PROP.proba_poz0(X[i][0]);
        }

    w[N-1] =MODE.emission_proba_struct_duplicated(DATA.counts[0],X[N-1][0],struct_n[0],DATA.context[0],outlier[0],DATA.duplicated[0])* MODE.kernel_hidden_0(X[N-1][0]) / PROP.proba_poz0(X[N-1][0]);
    for(int i=0;i<N;i++){ w_mat[i][0]=w[i];}

/// filter t>0 particles
    for(unsigned int t=1;t<DATA.T ;t++){

        PROP.set_y_range(ywsum_range[t],swsum_range[t],DATA.duplicated[t]);

        ESS=0;
        w=divide_vec(w, N, sum_vec(w,N));
        for (int i=0; i<N;i++){ ESS=ESS+pow(w[i],2);}
        if(ESS>4.0/N){
            sample_multinom_indices(rgen ,itemp_N1, (N-1), w, N);
            for(int i=0;i<(N-1);i++){
                A[i][t-1]=itemp_N1[i];
                w[i]=1;
                }
            w[N-1]=1;
            }
        else {
            for(int i=0;i<(N-1);i++)
                A[i][t-1]=i;
            }

        for(int i=0;i<(N-1);i++){
            PROP.set_u(X[A[i][t-1]][t-1]);
            X[i][t]=PROP.sample(rgen);
            w[i] =w[i]*MODE.emission_proba_struct_duplicated(DATA.counts[t],X[i][t],struct_n[t],DATA.context[t],outlier[t],DATA.duplicated[t])* MODE.kernel_hidden(X[i][t], X[A[i][t-1]][t-1]) / PROP.proba(X[i][t]);
        }
        PROP.set_u(X[A[N-1][t-1]][t-1]);
        w[N-1] =w[N-1]*MODE.emission_proba_struct_duplicated(DATA.counts[t],X[N-1][t],struct_n[t],DATA.context[t],outlier[t],DATA.duplicated[t])* MODE.kernel_hidden(X[N-1][t], X[A[N-1][t-1]][t-1]) / PROP.proba(X[N-1][t]);

        for(int i=0;i<N;i++){ w_mat[i][t]=w[i];}
    }


    index=sample_multinom_one_indices (rgen, indices,w ,N );
    part_np1[DATA.T-1]=X[index][DATA.T-1];

            /// Backtrack withoud backward sampling
    if(!backward_sampling){
        for(int t=DATA.T-2;t>=0;t--){
            index=A[index][t];
            part_np1[t]=X[index][t];			}
    }
    else{
        for(int t=DATA.T-2;t>=0;t--){
            if(abs(X[A[index][t]][t]-part_np1[t+1])<litle&&part_np1[t+1]>litle)
                index=A[index][t];
            else{
                for(int i=0;i<N;i++)
                    w[i]=w_mat[i][t]*MODE.kernel_hidden(part_np1[t+1],X[i][t]);
                index=sample_multinom_one_indices (rgen, indices,w ,N );
            }
            part_np1[t]=X[index][t];
        }
    }
}


void gibbs_step::CSMC_part_blocks (gsl_rng * rgen, model2 MODE, proposal PROP, datanew DATA,int N){

	unsigned int a,b, poz=0,window_size=2000;

	bool is_bk;
	double ESS=0;
	/// choose a starting position
	unsigned int iterations=(DATA.T/window_size);
    unsigned int randomize_positions=gsl_rng_uniform_int (rgen, window_size);

	for (unsigned int k=0;k<iterations;k++){

        poz=0;
		if(k!=0) poz=randomize_positions+k*window_size;

//        if(k==0||k==halfiterations){poz=0;}
//		else {poz=gsl_rng_uniform_int (rgen, (DATA.T-2));}
		a=poz;

		poz=a+gsl_rng_uniform_int (rgen, window_size); poz=poz>(DATA.T-1)?(DATA.T-1):poz;
		if(poz==(DATA.T-1)){ b=poz;}
		else {
			if(abs(part_n[poz]-part_n[poz+1])>litle||(part_n[poz+1]<litle)) {is_bk=true;} else {is_bk=false;}
			while((is_bk==false) &&(poz>a))
			{
				poz--;
				if(abs(part_n[poz]-part_n[poz+1])>litle||(part_n[poz+1]<litle)) {is_bk=true;}
			}
		}
		b=poz;

		if(b-a>0){

			for(unsigned int t=a;t<=b;t++){ X[N-1][t-a]=part_n[t];}
			for(unsigned int t=a;t<b;t++){ A[N-1][t-a]=N-1;}

			//fix t=a-1 particles
            PROP.set_y_range(ywsum_range[a],swsum_range[a],DATA.duplicated[a]);

			if(a>0){
				PROP.set_u(part_n[a-1]);
				for(int i=0;i<(N-1);i++){
					X[i][a-a]=PROP.sample(rgen);
					w[i] =MODE.emission_proba_struct_duplicated(DATA.counts[a],X[i][a-a],struct_n[a],DATA.context[a],outlier[a],DATA.duplicated[a])*
							MODE.kernel_hidden(X[i][a-a], part_n[a-1]) / PROP.proba(X[i][a-a]);}

				w[N-1] =MODE.emission_proba_struct_duplicated(DATA.counts[a],X[N-1][a-a],struct_n[a],DATA.context[a],outlier[a],DATA.duplicated[a])*
						MODE.kernel_hidden(X[N-1][a-a], part_n[a-1]) / PROP.proba(X[N-1][a-a]);
               	for(int i=0;i<N;i++){ w_mat[i][a-a]=w[i];}
			}

			else {
				for(int i=0;i<(N-1);i++){
					X[i][a-a]=PROP.sample_poz0(rgen);
					w[i] =MODE.emission_proba_struct_duplicated(DATA.counts[a],X[i][a-a],struct_n[a],DATA.context[a],outlier[a],DATA.duplicated[a])*
							MODE.kernel_hidden_0(X[i][a-a]) / PROP.proba_poz0(X[i][a-a]);}

				w[N-1] =MODE.emission_proba_struct_duplicated(DATA.counts[a],X[N-1][a-a],struct_n[a],DATA.context[a],outlier[a],DATA.duplicated[a])*
						MODE.kernel_hidden_0(X[N-1][a-a]) / PROP.proba_poz0(X[N-1][a-a]);
                for(int i=0;i<N;i++){ w_mat[i][a-a]=w[i];}
			}

			//filter t>0 particles
			for(unsigned int t=a+1;t<=b ;t++){

                PROP.set_y_range(ywsum_range[t],swsum_range[t],DATA.duplicated[t]);

				ESS=0;
				w=divide_vec(w, N, sum_vec(w,N));
				for (int i=0; i<N;i++){ ESS=ESS+pow(w[i],2);}
				if(ESS>4.0/N){
					sample_multinom_indices(rgen ,itemp_N1, (N-1), w, N);
					for(int i=0;i<(N-1);i++){
					    A[i][t-1-a]=itemp_N1[i];
					    w[i]=1;
                        }
					w[N-1]=1;
					}
				else {
				    for(int i=0;i<(N-1);i++){
				        A[i][t-a-1]=i;
//				        w_mat[i][t-a-1]=w[i];
				        }
                    }

				for(int i=0;i<(N-1);i++){
					PROP.set_u(X[A[i][t-1-a]][t-1-a]);
					X[i][t-a]=PROP.sample(rgen);
					w[i] =w[i]*MODE.emission_proba_struct_duplicated(DATA.counts[t],X[i][t-a],struct_n[t],DATA.context[t],outlier[t],DATA.duplicated[t])*
							MODE.kernel_hidden(X[i][t-a], X[A[i][t-1-a]][t-1-a]) / PROP.proba(X[i][t-a]);
				}
				PROP.set_u(X[A[N-1][t-1-a]][t-1-a]);
				w[N-1] =w[N-1]*MODE.emission_proba_struct_duplicated(DATA.counts[t],X[N-1][t-a],struct_n[t],DATA.context[t],outlier[t],DATA.duplicated[t])*
						MODE.kernel_hidden(X[N-1][t-a], X[A[N-1][t-1-a]][t-1-a]) / PROP.proba(X[N-1][t-a]);

                for(int i=0;i<N;i++){ w_mat[i][t-a]=w[i];}
			}

			//////////// fix b+1 and calculate particle weights
			if(b<DATA.T-1){
				for(int i=0;i<N;i++){	w[i] =w[i]*MODE.kernel_hidden(part_n[b+1], X[i][b-a]);}}

			index=sample_multinom_one_indices (rgen, indices,w ,N );
			part_np1[b]=X[index][b-a];

            /// Backtrack withoud backward sampling
            if(!backward_sampling){
                for(unsigned int t=b-1;t>a;t--){
                    index=A[index][t-a];
                    part_np1[t]=X[index][t-a];			}
            }
            else{
                for(unsigned int t=b-1;t>a;t--){
//                    if(a<10)cout<<a<<" "<<t-a<<endl;
                    if(abs(X[A[index][t-a]][t-a]-part_np1[t+1])<litle&&part_np1[t+1]>litle)
                        index=A[index][t-a];
                    else{
                        for(int i=0;i<N;i++){
                            w[i]=w_mat[i][t-a]*MODE.kernel_hidden(part_np1[t+1],X[i][t-a]);

                        }

                        index=sample_multinom_one_indices (rgen, indices,w ,N );
                    }
                    part_np1[t]=X[index][t-a];
                }
            }
			/// check how much of the ancient particle was updated
//			for(int t=b;t>=a;t--){			if(abs(part_n[t]-part_np1[t])>litle) {poz_update[t].first++;}	else 	{poz_update[t].second++;}	}
//
//			update_length=b-a+1;
//			while(update_length>0&&abs(part_n[b+1-update_length]-part_np1[b+1-update_length])<litle){update_length--;}
//			updates[b-a+1].first+=update_length;updates[b-a+1].second++;
///**//
			//
			//			for(int t=a;t<=b;t++){cout<<b<<" "<<t<<" "<<part_n[t]<<" "<<part_np1[t]<<endl;}
			//			cout<<" "<<b-a+1<<" "<<update_length<<endl;
			//			getchar();
			for(unsigned int t=a;t<=b;t++){part_n[t]=part_np1[t];}
		}
	}

	for(unsigned int t=0;t<DATA.T;t++){part_np1[t]=part_n[t];}

}


void gibbs_step::CSMC_struct (gsl_rng * rgen, model2 MODE, proposal PROP, datanew DATA, int N){
	updates_struct.clear();
	unsigned int a, b, poz=0,window_size=150;
	bool is_bk;
	double ESS;

	/// choose a starting position
	int iterations=(DATA.T/window_size),halfiterations=iterations/2;

	for (int k=0;k<iterations;k++){

		if(k==0||k==halfiterations){poz=0;}
		else {poz=gsl_rng_uniform_int (rgen, (DATA.T-2));}
		a=poz;

		poz=a+gsl_rng_uniform_int (rgen, window_size); poz=poz>(DATA.T-1)?(DATA.T-1):poz;
		if(poz==(DATA.T-1)){ b=poz;}
		else {
			if(indicator(struct_n[poz],struct_n[poz+1])==0) {is_bk=true;} else {is_bk=false;}
			while((is_bk==false) &&(poz>a))
			{
				poz--;
				if(indicator(struct_n[poz],struct_n[poz+1])==0) {is_bk=true;}}
		}
		b=poz;

		if(b-a>0){
			//			cout<<"update"<<a<<" " <<b<<endl;

			for(unsigned int t=a;t<=b;t++){ X[N-1][t-a]=struct_n[t];}
			for(unsigned int t=a;t<b;t++){ A[N-1][t-a]=N-1;}

			//t=a
			//// set proposal parameters
			PROP.set_alphap_struct(MODE.get_param()[15]);



			if(a>0){

                PROP.set_y(ywsum_range[a][PROP.window-1],swsum_range[a][PROP.window-1],DATA.duplicated[a]);
				PROP.set_y_range(ywsum_range[a],swsum_range[a],DATA.duplicated[a]);
				PROP.set_s(struct_n[a-1]);
				PROP.set_u(part_n[a]);

				for(int i=0;i<(N-1);i++){
					X[i][a-a]=PROP.sample_struct(rgen);
					w[i] =MODE.emission_proba_struct_duplicated(DATA.counts[a],part_n[a],X[i][a-a],DATA.context[a],outlier[a],DATA.duplicated[a])*
							MODE.kernel_struct(X[i][a-a], struct_n[a-1]) / PROP.proba_struct(X[i][a-a]);}

				w[N-1] =MODE.emission_proba_struct_duplicated(DATA.counts[a],part_n[a],X[N-1][a-a],DATA.context[a],outlier[a],DATA.duplicated[a])*
						MODE.kernel_struct(X[N-1][a-a], struct_n[a-1]) / PROP.proba_struct(X[N-1][a-a]);
			}

			else {
				for(int i=0;i<(N-1);i++){
					X[i][a-a]=PROP.sample_struct_0(rgen);
					w[i] =MODE.emission_proba_struct_duplicated(DATA.counts[a],part_n[a],X[i][a-a],DATA.context[a],outlier[a],DATA.duplicated[a])*
							MODE.kernel_struct_0(X[i][a-a]) / PROP.proba_struct_0(X[i][a-a]);}

				w[N-1] =MODE.emission_proba_struct_duplicated(DATA.counts[a],part_n[a],X[N-1][a-a],DATA.context[a],outlier[a],DATA.duplicated[a])*
						MODE.kernel_struct_0(X[N-1][a-a]) / PROP.proba_struct_0(X[N-1][a-a]);
			}


			//filter t>0 particles
			for(unsigned int t=a+1;t<=b ;t++){

				PROP.set_y(ywsum_range[t][PROP.window-1],swsum_range[t][PROP.window-1],DATA.duplicated[t]);
				PROP.set_y_range(ywsum_range[t],swsum_range[t],DATA.duplicated[t]);

				PROP.set_u(part_n[t]);
				ESS=0;
				w=divide_vec(w, N, sum_vec(w,N));
				for (int i=0; i<N;i++){ ESS=ESS+pow(w[i],2);}

				//				cout<<"ESS struct "<<ESS<<" "<<2.0/N<<endl; getchar();
				if(ESS>2.0/N){
					sample_multinom_indices(rgen ,itemp_N1, (N-1),  w, N);
					for(int i=0;i<(N-1);i++){A[i][t-1-a]=itemp_N1[i];w[i]=1;}
					w[N-1]=1; }
				else{ for(int i=0;i<(N-1);i++){A[i][t-1-a]=	i;}
				}

				for(int i=0;i<(N-1);i++){
					PROP.set_s(X[A[i][t-1-a]][t-1-a]);
					X[i][t-a]=PROP.sample_struct(rgen);
					w[i] =w[i]*MODE.emission_proba_struct_duplicated(DATA.counts[t],part_n[t],X[i][t-a],DATA.context[t],outlier[t],DATA.duplicated[t])*
							MODE.kernel_struct(X[i][t-a], X[A[i][t-1-a]][t-1-a]) / PROP.proba_struct(X[i][t-a]);}

				PROP.set_s(X[A[N-1][t-1-a]][t-1-a]);
				w[N-1] =w[N-1]*MODE.emission_proba_struct_duplicated(DATA.counts[t],part_n[t],X[N-1][t-a],DATA.context[t],outlier[t],DATA.duplicated[t])*
						MODE.kernel_struct(X[N-1][t-a], X[A[N-1][t-1-a]][t-1-a]) / PROP.proba_struct(X[N-1][t-a]);
			}


			//////////// fix b+1 and calculate particle weights
			if(b<DATA.T-1){
				for(int i=0;i<N;i++){	w[i] =w[i]*MODE.kernel_struct(struct_n[b+1], X[i][b-a]);}}

			index=sample_multinom_one_indices (rgen, indices,w ,N );
			struct_np1[b]=X[index][b-a];

			for(unsigned int t=b-1;t>a;t--){
				index=A[index][t-a];
				struct_np1[t]=X[index][t-a];			}
			// check how much was updated

			//			update_length_struct=b-a+1;
			//			while(update_length_struct>0&&abs(struct_n[b+1-update_length_struct]-struct_np1[b+1-update_length_struct])<litle){
			//				update_length_struct--;}
			//			updates_struct[b-a+1].first+=update_length_struct;updates_struct[b-a+1].second++;

			//			ar();
			for(unsigned int t=a;t<=b;t++){struct_n[t]=struct_np1[t];}
		}
	}
	for(unsigned int t=0;t<DATA.T;t++){struct_np1[t]=struct_n[t];}
}


void gibbs_step::Simulate_counts(gsl_rng * rgen,model2 MODE, datanew *DATA){

    float * x=new float[DATA->T];
    float * a=new float[DATA->T];
    DATA->poz_counts.clear();

	for (unsigned int t=0;t<DATA->T;t++){
        x[t]=gsl_ran_poisson(rgen,part_n[t]*struct_n[t]/MODE.a);
        a[t]=gsl_ran_gamma(rgen,1/MODE.kappa,MODE.a*MODE.kappa);
        DATA->counts[t]=gsl_ran_poisson(rgen,x[t]*a[t]);
        if(DATA->counts[t]>0){
            (DATA->poz_counts).push_back(make_pair(make_pair(DATA->crom,DATA->strand[0]),make_pair(t,DATA->counts[t])));
        }
    }
    delete x; delete a;
}

