# include <iostream>
# include <fstream>
# include <string>

# include <stdio.h>
# include <sys/stat.h>

# include "functions.h"
# include "data.h"
# include "model.h"
# include "estimate_parameters.h"
# include "gibbs_step.h"

using namespace std;

void run_PG(string SMC_type, string org_name, string strand, string crom, string data_folder, string results_folder,unsigned int N, bool average_parameters, bool mask_duplicated,
             bool Continue_iter, float max_u, float discretization_step, unsigned int Itpar, unsigned int Itpar_out, unsigned int Itpar_out_first ,unsigned int Itpar_start_write,
             double* param , unsigned int npars,bool* ind_param , vector<float>* nb_table,	gsl_rng* rgen);

int main(int argc, char *argv[]) {

cout<<" >>>>>>>>>>> \n Parseq arguments:	<estimate> <organism> <strand> <crom> <data_folder> <results_folder> <parseq_folder>"<<endl;

    string estimate=string(argv[1]);
    string org_name=string(argv[2]);
    string initstrand=string(argv[3]);
    string initcrom=string(argv[4]);
    string data_folder=  string(argv[5]);
    string results_folder=  string(argv[6])+"/";
    string parseq_folder=  string(argv[7]);



    vector<string> chromosomes;
    vector<string> strands;
    string counts_folder=data_folder+"/counts/";


    string SMC_type="PG_struct";
//    string    SMC_type="PG_struct_level";
//    string    SMC_type= "PG_struct";
//    string    SMC_type="PG_simulate";
//    string    SMC_type="PG_no_struct";

    if(initstrand=="all") {strands.push_back("+");strands.push_back("-");}
    else  strands.push_back(initstrand);

    if(initcrom=="genome_frag"){
        chromosomes=get_chromosomes(counts_folder,org_name,"yes");
//        for (int st=0;st<strands.size();st++){
//            for (int ch=0;ch<chromosomes.size();ch++){
////                cout<<"Split chromosome: "<<chromosomes[ch]<<endl;
//////                system (("echo "+parseq_folder+"divide_genome.sh "+string(data_folder)+" "+strands[st]+" "+chromosomes[ch]+" "+org_name+".chrom.sizes "+"1000000").c_str());
////                system ((""+parseq_folder+"divide_genome.sh "+string(data_folder)+" "+strands[st]+" "+chromosomes[ch]+" "+org_name+".chrom.sizes "+"1000000"+"").c_str());
//            }
//        }
    }
    else {
        if(initcrom=="genome")
            chromosomes=get_chromosomes(counts_folder,org_name,"no");
        else
            chromosomes.push_back(initcrom);
    }

/////////////////////////////


	/** READ ALGORITHM PARAMETERS	**/
	unsigned int npars_alg=13; double * parameters_alg; parameters_alg=new double[npars_alg];
	read_algorithm_parameters_new(parseq_folder, string("Parameters_parseq"), parameters_alg,	npars_alg);

    unsigned int npars=19;
	unsigned int N=(unsigned int)parameters_alg[0];
	unsigned int Itpar=(unsigned int)parameters_alg[2];
	unsigned int Itpar_out=(unsigned int) parameters_alg[3];
	unsigned int Itpar_start_write=(unsigned int) parameters_alg[4];
	bool Continue_iter=parameters_alg[8];
	bool mask_duplicated=parameters_alg[10];
	bool average_parameters=parameters_alg[11];

    vector<float>* nb_table;
	double* param; param=new double [npars];bool* ind_param; ind_param=new bool [npars];
	gsl_rng* rgen;
	rgen=gsl_rng_alloc(gsl_rng_rand48);
    gsl_rng_set(rgen,time(0));
//    gsl_rng_set(rgen,1);
	struct stat st;
	if(stat((results_folder).c_str(),&st) != 0) system(("mkdir "+results_folder).c_str());

/** compute or read emission parameters**/
    read_model_parameters(data_folder, org_name,string("Parameters_initial"),param,ind_param, npars);
    int max_u=200; float discretization_step=20;
    nb_table=calc_emission_table_log(counts_folder,param[17],param[18],max_u,discretization_step);

    unsigned int Itpar_out_fast=estimate=="fast"?Itpar_out:Itpar_out*10;

    if(!average_parameters){
        cout<<"Running iterations to estimate parameters for "<<strands.size()<<" strands and  "<<chromosomes.size()<<" chromosome fragments"<<endl;
        for (unsigned int st=0;st<strands.size();st++){
            for ( unsigned int ch=0;ch<chromosomes.size();ch++){
                string strand=(strands[st]);
                string crom=(chromosomes[ch]);
                run_PG(SMC_type,  org_name,  strand,  crom,  data_folder,  results_folder, N, false, mask_duplicated, Continue_iter, max_u, discretization_step,
                    Itpar,  Itpar_out ,Itpar_out_fast , Itpar_start_write, param ,  npars, ind_param ,  nb_table,	rgen);
            }
        }
    }

    if(estimate=="best"){
        cout<<"Running best option for "<<strands.size()<<" "<<chromosomes.size()<<endl;
        for (unsigned int st=0;st<strands.size();st++){
            for (unsigned int ch=0;ch<chromosomes.size();ch++){
                string strand=(strands[st]);
                string crom=(chromosomes[ch]);
                cout<<crom<<strand<<endl;
                run_PG(SMC_type,  org_name,  strand,  crom,  data_folder,  results_folder, N, true, mask_duplicated, true, max_u, discretization_step, Itpar,  Itpar_out ,Itpar_out , Itpar_start_write, param ,  npars, ind_param ,  nb_table,	rgen);
            }
        }
    }

	///////////////////////////////////////////////////////////////////////////
	cout<<"end of PG iterations"<<endl;

	return 0;
}



void run_PG(string SMC_type, string org_name, string strand, string crom, string data_folder, string results_folder,unsigned int N, bool average_parameters, bool mask_duplicated,
             bool Continue_iter, float max_u, float  discretization_step, unsigned int Itpar, unsigned int Itpar_out ,unsigned int Itpar_out_first ,unsigned int Itpar_start_write,
             double* param , unsigned int npars,bool* ind_param , vector<float>* nb_table,	gsl_rng* rgen){

    string results_folder_crom=string(results_folder+"_"+strand+crom+"/");
    struct stat st;
    if(stat((results_folder_crom).c_str(),&st) != 0) 	 system(("mkdir "+results_folder_crom).c_str());

    bool restart=true,restart_parameters_genome=true;
    if(Continue_iter || average_parameters) restart=false;

    ///**	read data		**///
    datanew DATA1(data_folder,	org_name, strand, crom,0);
    DATA1.read_counts();
    cout<<"Read the counts"<<endl;
    if(mask_duplicated) {cout<<"Read duplicated data"<<endl;	DATA1.read_duplicated();}
    DATA1.ywsum=(int*)DATA1.calc_localsum((float*)DATA1.counts,10); ///** ywsum=sum(y[t:t+window])
    DATA1.calc_ymean_ymax();

    ///** Declare variables (particles) **///
    double* part_np1= new double[DATA1.T];
    double*	part_n= new double[DATA1.T]; ///// np1 is the new particle and n is the old one
    double* struct_np1= new double[DATA1.T];
    double* struct_n= new double[DATA1.T];
    int *outlier= new  int[DATA1.T];

    ///** INITIALIZE OBJECTS
    size_t window_prop_max=2;// represents the number of components of the proposal dependent on counts
//    double* prop_weights=new double[window_prop_max+3];
    DATA1.get_initial_particles (results_folder_crom, Continue_iter, part_n, struct_n, param, outlier);
    model2 MODE1(param, DATA1.ymax, DATA1.ymean,DATA1.yphi, npars,nb_table, max_u ,discretization_step);

    proposal PROP1(1,1,0,DATA1.duplicated[0],param[15],  1 , window_prop_max);/// last argument is windows proposal
//                (xut, xst, xywmt,duplicated,xalpha_p_struct,  xzetap,  int window){

     cout<<"Initializing model and proposal"<<endl;
    PROP1.set_model(MODE1);


    gibbs_step GIBS1(SMC_type, N, DATA1, MODE1, PROP1);

    GIBS1.set_u_n(part_n);
    GIBS1.set_s_n(struct_n);
    GIBS1.set_outlier(outlier);
    calc_localsum_range(DATA1.counts,PROP1.window,PROP1.window_range,DATA1.T,GIBS1.ywsum_range);

    level_estimation ESTIM(DATA1.T, DATA1.counts, MODE1, PROP1, DATA1.context);

    cout<<endl<<" There will be "<<Itpar_start_write<<" burn-in interations from "<<Itpar <<" total"<<endl;

    ///**
    for (unsigned int n=0;n<Itpar;n++){

       ///** SIMULATE COUNTS
        if(SMC_type=="PG_simulate"){
            GIBS1.Simulate_counts (rgen, MODE1,&DATA1);
            DATA1.ywsum=(int*)DATA1.calc_localsum2((float*)DATA1.counts,window_prop_max);		//ywsum is the sum of counts in a window of window starting from teh position.
            calc_localsum_range(DATA1.counts,PROP1.window,PROP1.window_range,DATA1.T,GIBS1.ywsum_range);
            DATA1.calc_ymean_ymax();
        }

        if(n==0){
            if(average_parameters){
                ESTIM.average_sample_param ((results_folder+"Parameters_genome").c_str());
                MODE1.update_param(ESTIM.param);
                for (unsigned int i=0; i<npars; i++){ind_param[i]=0;}
            }
            GIBS1.set_model(MODE1);
        }

        if((n %Itpar_out)==0){
            cout<<"\n at interation: "<<n<<endl;
            for (unsigned int i=0; i<npars;i++) cout<<MODE1.get_param()[i]<<" "; cout<<endl;
        }
        calc_localsum_range(GIBS1.struct_n,PROP1.window,PROP1.window_range,DATA1.T,GIBS1.swsum_range);

        GIBS1.SMC(rgen);  /** Particle Gibbs **/

        part_np1=GIBS1.get_u_np1();
        struct_np1=GIBS1.get_s_np1();
        ESTIM.update_estimation(part_np1,struct_np1, MODE1);
        ESTIM.sample_particle_break(rgen);
        ESTIM.sample_param (rgen,ind_param[0],ind_param[1],ind_param[2],ind_param[3],ind_param[4],ind_param[7],ind_param[10],ind_param[14],ind_param[6]); 		//bool alpha, beta_0, beta, gamma, lambda, zeta, precision eta
        ESTIM.sample_outlier(rgen,1); // compulsory if error is not 0
        ESTIM.sample_error_param(rgen,ind_param[11],ind_param[12]);

///*/// update proposal weights
//ESTIM.get_proposal_weights(prop_weights,DATA1.duplicated,GIBS1.ywsum_range,GIBS1.swsum_range);
//for( int www=0;www<window_prop_max+3;www++)
//cout<<"weight: "<<www<<" "<<PROP1.wmixture[www]<<" "<<PROP1.wmixture_cum[www]<<endl;
//double * weights,double* weights_cum, int* duplicated,int **ywrange, double**swrange
///*///

        for (unsigned int j=0;j<npars;j++){	param[j]=ESTIM.param[j];}
        MODE1.update_param(ESTIM.param);

        PROP1.set_zetap(DATA1.ymean*(MODE1.get_param()[1]/MODE1.get_param()[6]+1));
        PROP1.set_model(MODE1);
        GIBS1.set_u_n(part_np1); /** update the ancient (n) particle with the (n+1)**/
        GIBS1.set_s_n(struct_np1);
        GIBS1.set_outlier(ESTIM.outlier);
        GIBS1.set_model(MODE1);
        part_n=GIBS1.get_u_n();
        struct_n=GIBS1.get_s_n();
        outlier=ESTIM.outlier;

        if(n>=Itpar_start_write){     /** 	WRITE PARAMETERS AND PARTICLES	**/

            ofstream file;
            if(!average_parameters){
                if((n %(Itpar_out))==0){
                    append_vec(param, npars, results_folder_crom,"Parameters",file,restart);
                    append_vec(PROP1.wmixture, PROP1.window+3, results_folder_crom,"Parameters_Proposal",file,restart);
                    append_vec(param, npars, results_folder,"Parameters_genome",file,restart_parameters_genome);
                    restart_parameters_genome=false;
                }
            }

            if((!average_parameters)&&((n %Itpar_out_first)==0)){
                append_vec(part_np1, DATA1.T, results_folder_crom,"Particles",file,restart);
                append_vec(struct_np1, DATA1.T, results_folder_crom,"Particles_struct",file,restart);
                append_vec(ESTIM.bk, (DATA1.T-1), results_folder_crom,"Breakpoints",file,restart);
                append_vec(ESTIM.outlier, DATA1.T, results_folder_crom,"Outlier",file,restart);
                            restart=false;
            }

            if(average_parameters&&((n %Itpar_out)==0)){
                append_vec(part_np1, DATA1.T, results_folder_crom,"Particles",file,restart);
                append_vec(struct_np1, DATA1.T, results_folder_crom,"Particles_struct",file,restart);
                append_vec(ESTIM.bk, (DATA1.T-1), results_folder_crom,"Breakpoints",file,restart);
                append_vec(ESTIM.outlier, DATA1.T, results_folder_crom,"Outlier",file,restart);
                            restart=false;
            }
            file.close();

        }

    }
}
