#include <iostream>
#include <fstream>
#include <string>
#include <sstream>
#include <map>
#include <cstdlib>
#include <cmath>
#include <dirent.h>
#include <vector>
using namespace std;


struct partial{
        string folder, crom;
        int start, length;
        partial(string folder,string crom,int start,int length){
        this->folder=folder;
        this->crom=crom;
        this->start=start;
        this ->length=length;
        }
};

vector< pair <string,int> > get_chromosomes(string counts_folder,string org_name,string type,string crom_name);
map<int,double> score_comp(double * x, double* score, int T, double m);

int main(int argc, char *argv[]){


    float elimit=0,penalty=0.005; string penalty_string="0.005";
    string org, strand, crom,initcrom,initstrand, results_folder, counts_folder,elimit_string, data_type;
    int NRL;
    vector<string> strands;
    vector< pair <string,int> > croms, partcroms;
    ifstream filebk, filepart;
    ofstream fileobk,fileopath;
    if(argc==1){
        cout<<"Arguments should be: \n << expression_treshold >>,\n << organism >>,\n << strand(\"all\" if for both strands)>>,\n << chromosome (\"genome\" if for whole genome)>>, \n<< counts_folder>>, \n<< results_folder >>,\n[score penalty (0.05 by default)]\n"<<endl;
        return 1;
    }

    istringstream iss(argv[1]);iss >> elimit; elimit_string=string(argv[1]);
	org=string(argv[2]);
	initstrand=string(argv[3]);
	initcrom=string(argv[4]);
	data_type="full";
	counts_folder=  string(argv[5])+"/counts/";
	results_folder=  string(argv[6])+"/";
    if(argc==7){  cout<<"using default:  "<< penalty<<" penalty for score calculation"<<endl;       }

  	if(argc>7){
        istringstream iss2(argv[8]);iss2 >> penalty;
        penalty_string=string(argv[8]);
        cout<<"using:  "<< penalty<<" penalty for score calculation"<<endl;
        }

    cout<<"Arguments: "<<endl<<"\t elimit: "<<elimit<<endl<<"\t results_folder "
    <<results_folder<<endl<<"\t data_folder "<<counts_folder<<endl<< "strand"<<strand<<endl;

    /************************ get folder names for the chromosome**************/

///get chromosome list
    croms=get_chromosomes(counts_folder,org,"complete",initcrom);

    if(initstrand=="all")   {strands.push_back("+");  strands.push_back("-");}
    else    strands.push_back(initstrand);
    if(data_type=="part") partcroms=get_chromosomes(counts_folder,org,"part",initcrom);
    if(data_type=="full") partcroms=get_chromosomes(counts_folder,org,"complete",initcrom);
//cout<<"data: "<<data_type<<endl; exit(2);
    bool flagfirst; // flag 1 if a new file to write; 0 if appending to an existing file
    for (unsigned int sindex=0;sindex<strands.size();sindex++){
        flagfirst=true;
        for (unsigned int cindex=0;cindex<croms.size();cindex++){
            string dummy, crompart, cromtemp;
            int T,Tall;
            double level, after;
            int startpart;
            crom=croms[cindex].first; strand=strands[sindex];
            Tall=croms[cindex].second;
            cout<<strand<<" "<<crom<<" ::\t "<<Tall<<endl;
//            sleep(2);

            int* allbk=new int[Tall];
//            double*allexpr=new double[Tall];
            double* allmeanexpr=new double[Tall];
            double* allvarexpr=new double[Tall];
//            map<int,double>* allfreq; allfreq=new map<int, double>[Tall];
            double *alltrans=new double[Tall];
            double* allproba5=new double[Tall];
            double* allproba3=new double[Tall];
            double* allprobastart=new double[Tall];
            double* allprobaend=new double[Tall];
/// find folders with names containing chromosome ( and starting position)

            vector <partial> part_crom_names;
            vector<partial>::iterator part_crom;
            string name;
            string tempstr;int tempint;


            unsigned int indexcrom=0;
            if(data_type=="part")
                while (indexcrom<partcroms.size()) {
                    name= partcroms[indexcrom].first;
                    if(name.find(string(crom+"_part"),0)<1000) {
                        tempstr=name.substr(name.find("part",2)+5);
                        istringstream tempstream(tempstr.substr(0,tempstr.find("_")));tempstream>>tempint;
                        partial part(string("_"+strand+name),name,tempint,partcroms[indexcrom].second);
                        part_crom_names.push_back(part) ;
                    }
                    indexcrom++;
                }
            else if (data_type=="full")
                while (indexcrom<partcroms.size()) {
                    name= partcroms[indexcrom].first;
                    if(name.find(string(crom+"_part"),0)>1000) {
                        partial part(string("_"+strand+name),name,0,partcroms[indexcrom].second);
                        part_crom_names.push_back(part) ;
                    }
                    indexcrom++;
                }


           for (part_crom = part_crom_names.begin();part_crom!=part_crom_names.end();part_crom++){

                /*************** for the partial chromosome read information, compute profiles and then update the all profiles**************/
                crompart=(*part_crom).crom;
                startpart=(*part_crom).start;
                T=(*part_crom).length;
                string  results_folder_crom= string(results_folder+(*part_crom).folder+"/");
                string  arginbk=string(results_folder_crom+"Breakpoints");
                string  arginpart=string(results_folder_crom+"Particles");
                string  argobk=string(results_folder_crom+"Breakpoints_update");

                int* bk=new int[T];
                double* expr=new double[T];
                double* meanexpr=new double[T];
                double* varexpr=new double[T];
                map<int,double>* freq; freq=new map<int, double>[T];
                double* trans=new double[T];
                double* proba5=new double[T];
                double* proba3=new double[T];
                double* probastart=new double[T];
                double* probaend=new double[T];
                for (int t=0; t<T;t++){
                    meanexpr[t]=0;
                    varexpr[t]=0;
                    trans[t]=0;
                    proba5[t]=0;
                    proba3[t]=0;
                    probastart[t]=0;
                    probaend[t]=0;
                }


                /// get length of BK lines and number of lines
                NRL=0;
                filebk.open(arginbk.c_str(),ios::in);
                    getline(filebk,dummy);
                    double breaklengthcorrection=T-dummy.length()/2;
                    while(filebk)   {getline(filebk,dummy); NRL++;}
                filebk.close();

                cout<<"Assembling chromosome fragment \t "<< crompart<<" of length: "<<T<<" from "<<NRL<<" particles."<<endl;// sleep(2);
                filebk.open(arginbk.c_str(),ios::in);
                filepart.open(arginpart.c_str(),ios::in);
            //cout<<"arginpart"<<arginpart<<endl;
                if(elimit>0) {         fileobk.open(argobk.c_str());    }



                for (int nr=0; nr<NRL;nr++){
//cout<<nr<<endl; sleep(10);
                ///read the nth line
                    if(strand=="+"){
                        for (int t=0; t<T;t++){
                            filepart >> expr[t];
                            meanexpr[t]+=expr[t];
                            varexpr[t]+=pow(expr[t],2);
                        }
                        for (int t=0; t<(T-1);t++)
                             filebk >> bk[t];
                        if(breaklengthcorrection>0) {   bk[T-1]=bk[T-2];} else filebk >> bk[T-1];
                    }
                    else{
                        for (int t=0; t<T;t++){
                            filepart >> expr[T-t-1];
                            meanexpr[T-t-1]+=expr[T-t-1];
                            varexpr[T-t-1]+=pow(expr[T-t-1],2);
                        }
                        for (int t=0; t<(T-1);t++){     filebk >> bk[T-t-1];    }
                        if(breaklengthcorrection>0) {   bk[0]=bk[1];} else filebk >> bk[0];
                    }

                /// update bk from the nth line and update the frequency of breakpoints
                    for (int t=1; t<(T-1);t++){

                    if(elimit>0){
                        level=expr[t];
                /// get next value in function of strand
                        if(strand=="+") after=expr[t+1]; else {after=expr[t-1];}

                        if( (level>elimit)&(after<elimit)){  if(bk[t]==9)    bk[t]=1;  }
                        if( (level<elimit)&(after<elimit)){                bk[t]=5;  }
                        if( (level<elimit)&(after>elimit)){    if(bk[t]==2)    bk[t]=6;  }
                        }
                        freq[t][bk[t]]+=1.0;
                    }

                /// write the nth line to breakpoint file
                     if(elimit>0){
                         for (int t=0; t<T;t++){    fileobk<<bk[t]<<"\t";  }
                         fileobk<<endl;
                     }
                }

                filebk.close(); filepart.close();
                if(elimit>0){            fileobk.close();       }



                /// write the profile

                for (int t=0; t<T;t++){
                    trans[t]=(freq[t][0]+freq[t][1]+freq[t][2]+freq[t][3]+freq[t][4]+freq[t][9])/(double)NRL;
                    proba5[t]=(freq[t][2]+freq[t][6])/(double)NRL;
                    proba3[t]=(freq[t][1]+freq[t][9])/(double)NRL;
                    probastart[t]=(freq[t][6])/(double)NRL;
                    probaend[t]=(freq[t][1])/(double)NRL;
                    meanexpr[t]=meanexpr[t]/(double)NRL; //if (t==125600) cout<<   "example:: "<<   meanexpr[t] <<endl;
                    varexpr[t]=varexpr[t]/NRL-pow(meanexpr[t],2);
                }

                if(NRL==0)
                    for (int t=0; t<T;t++){
                        trans[t]=0; proba5[t]=0;proba5[t]=0; meanexpr[t]=0;probastart[t]=0; probaend[t]=0;varexpr[t]=0;
                        }

///        /************************  put the partial chromosome in the full chromosome ***************************/
               for (int t=0; t<T;t++){
                    allbk[t+startpart-1]=bk[t];
                    alltrans[t+startpart-1]=trans[t];
                    allproba3[t+startpart-1]=proba3[t];
                    allproba5[t+startpart-1]=proba5[t];
                    allprobaend[t+startpart-1]=probaend[t];
                    allprobastart[t+startpart-1]=probastart[t];
                    allmeanexpr[t+startpart-1]=meanexpr[t];
                    allvarexpr[t+startpart-1]=varexpr[t];
                }
            }


//            cout<<"writing profiles"<<endl;

            if(flagfirst)   fileopath.open((results_folder+"Trans_"+strand+"_"+elimit_string+".wig").c_str(),ios_base::out);
            else            fileopath.open((results_folder+"Trans_"+strand+"_"+elimit_string+".wig").c_str(),ios_base::app);
            fileopath<<string("fixedStep  chrom="+crom+" start=1  step=1")<<endl;
            for (int t=0; t<Tall;t++){ fileopath<<alltrans[t]<<endl;}
            fileopath.close();

            ///// 5'
            if(flagfirst)   fileopath.open((results_folder+"5'_"+strand+"_"+elimit_string+".wig").c_str(),ios_base::out);
            else   fileopath.open((results_folder+"5'_"+strand+"_"+elimit_string+".wig").c_str(),ios_base::app);
            fileopath<<string("fixedStep  chrom="+crom+" start=1  step=1")<<endl;
            for (int t=0; t<Tall;t++){        fileopath<<allproba5[t]<<endl;        }
            fileopath.close();

            ///// 3'
            if(flagfirst) fileopath.open((results_folder+"3'_"+strand+"_"+elimit_string+".wig").c_str(),ios_base::out);
            else fileopath.open((results_folder+"3'_"+strand+"_"+elimit_string+".wig").c_str(),ios_base::app);
            fileopath<<string("fixedStep  chrom="+crom+" start=1  step=1")<<endl;
            for (int t=0; t<Tall;t++){                fileopath<<allproba3[t]<<endl;        }
            fileopath.close();

                       ///// 5'
            if(flagfirst) fileopath.open((results_folder+"5'trans_"+strand+"_"+elimit_string+".wig").c_str(),ios_base::out);
             else fileopath.open((results_folder+"5'trans_"+strand+"_"+elimit_string+".wig").c_str(),ios_base::app);
            fileopath<<string("fixedStep  chrom="+crom+" start=1  step=1")<<endl;
            for (int t=0; t<Tall;t++){        fileopath<<allprobastart[t]<<endl;        }
            fileopath.close();

            ///// 3'
            if(flagfirst) fileopath.open((results_folder+"3'trans_"+strand+"_"+elimit_string+".wig").c_str(),ios_base::out);
            else fileopath.open((results_folder+"3'trans_"+strand+"_"+elimit_string+".wig").c_str(),ios_base::app);
            fileopath<<string("fixedStep  chrom="+crom+" start=1  step=1")<<endl;
            for (int t=0; t<Tall;t++){                fileopath<<allprobaend[t]<<endl;        }
            fileopath.close();


            ///// Mean expression
            if(flagfirst)  fileopath.open((results_folder+"Expression_"+strand+".wig").c_str(),ios_base::out);
            else fileopath.open((results_folder+"Expression_"+strand+".wig").c_str(),ios_base::app);
            fileopath<<string("fixedStep  chrom="+crom+" start=1  step=1")<<endl;
            for (int t=0; t<Tall;t++){  fileopath<<allmeanexpr[t]<<endl;            }
            fileopath.close();

            if(flagfirst) fileopath.open((results_folder+"Var_"+strand+".wig").c_str(),ios_base::out);
            else fileopath.open((results_folder+"Var_"+strand+".wig").c_str(),ios_base::app);
            fileopath<<string("fixedStep  chrom="+crom+" start=1  step=1")<<endl;
            for (int t=0; t<Tall;t++){  fileopath<<allvarexpr[t]<<endl;            }
            fileopath.close();



            /// Compute score from profiles
//       cout<<"Writing 5' 3'  score"<<endl;
            double* score5=new double[Tall];
            double* score3=new double[Tall];

            map<int,double> pozs5= score_comp(allproba5,score5,Tall,penalty);
            map<int,double> pozs3= score_comp(allproba3,score3,Tall,penalty);
            map<int,double>::iterator it;

        //// write score profiles

            if(flagfirst) fileopath.open((results_folder+"3'_score"+strand+"_"+elimit_string+".wig").c_str(),ios_base::out);
            else fileopath.open((results_folder+"3'_score"+strand+"_"+elimit_string+".wig").c_str(),ios_base::app);
            fileopath<<string("fixedStep  chrom=")+crom+string(" start=1  step=1")<<endl;
            for (int t=0; t<Tall;t++){
                 fileopath<<score3[t]<<endl;
            }
            fileopath.close();
            if(flagfirst) fileopath.open((results_folder+"5'_score"+strand+"_"+elimit_string+".wig").c_str(),ios_base::out);
            else fileopath.open((results_folder+"5'_score"+strand+"_"+elimit_string+".wig").c_str(),ios_base::app);
            fileopath<<string("fixedStep  chrom=")+crom+string(" start=1  step=1")<<endl;
            for (int t=0; t<Tall;t++){
                 fileopath<<score5[t]<<endl;
            }
            fileopath.close();
//
//            if(cindex==0) {
//                cout<<"cindex :  "<<cindex<<endl;
//                sleep(10);
//                fileopath.open((results_folder+"breakpoints_3_5_"+strand+"_"+elimit_string+".bed").c_str(),ios_base::out);
//            }
//            else
            if(flagfirst) fileopath.open((results_folder+"breakpoints_3_5_"+strand+"_"+elimit_string+".bed").c_str(),ios_base::out);
            else fileopath.open((results_folder+"breakpoints_3_5_"+strand+"_"+elimit_string+".bed").c_str(),ios_base::app);

            it=pozs3.begin();
            while( it != pozs3.end()){
                if( (*it).second>0.2) fileopath<<crom<<"\t"<<(*it).first<<"\t"<<(*it).first<<"\t 3end"<<"\t"<<(*it).second<<"\t"<<strand<<endl;
                it++;
            }
            it=pozs5.begin();
            while( it != pozs5.end()){
                if( (*it).second>0.2) fileopath<<crom<<"\t"<<(*it).first<<"\t"<<(*it).first<<"\t 5end"<<"\t"<<(*it).second<<"\t"<<strand<<endl;
                 it++;
            }
            fileopath.close();
            flagfirst=false;

        }
    }

   return 0;
}






vector< pair <string,int> > get_chromosomes(string counts_folder,string org_name,string type,string crom_name){
    unsigned int length; string chr;
    vector< pair <string,int> > chrs;

/**get chromosomes from chrom.sizes**/

	ifstream  file;
	file.open((counts_folder+org_name+".chrom.sizes").c_str());
	if(!file) {cerr<<".chrom.sizes not read; "<<(counts_folder+org_name+".chrom.sizes").c_str()<<" Probably the counts folder is wrong."<< endl; exit(1);}
    if (crom_name=="genome") {
        while ((file >> chr>>length).good()){
                if( type=="complete")
                   if(chr.find("_part_")>chr.length())
                    chrs.push_back(make_pair(chr,length));
                if(type=="part")
                   if(chr.find("_part_")<=chr.length())
                    chrs.push_back(make_pair(chr,length));
        }
    }
    else {
         while ((file >> chr>>length).good()){
                if( type=="complete")
                   if(crom_name==chr&&chr.find("_part_")>chr.length())
                    chrs.push_back(make_pair(chr,length));
                if(type=="part")
                   if(chr.find(crom_name)<=chr.length()&&chr.find("_part_")<=chr.length())
                    chrs.push_back(make_pair(chr,length));
        }
    }
	file.close();

    cout<<"The following chromosomes were found in the .chrom.sizes file:"<<endl;
    for (unsigned int ch=0;ch<chrs.size();ch++){
        cout<<"crom: "<<chrs[ch].first<<endl;
    }
    cout<<endl;

	return chrs;

};

///########################################################







map<int,double> score_comp(double * x, double* score, int T, double m){
    map<int,double> pozs;
   	bool inside=false;
   	double cumul,weightmean,highscore;
   	int high,startw,poz;
	int high2;

	double cumul2;double cumul3;
  	double limit=0.00000001;
  	score[0]=x[0]-m;  	if(score[0]<limit) score[0]=0;
  	//else {	inside=true;		startw=0;		high=0;	highscore=score[0];	}
	int multiple; double multiplecumul;

    for (int t=1;t<T;t++){
        if(!inside) {score[t]=x[t]-m;  if(score[t]<0)score[t]=0;}
        if(inside) {score[t]=score[t-1]+x[t]-m;  if(score[t]<0)score[t]=0;}

        if(!inside){
            if(score[t]>limit) {	inside=true;		startw=t;		high=t;	highscore=score[t];	}
        }
        else {
         	if(score[t]>limit){                if(highscore<score[t]){highscore=score[t]; high=t;}            	}
            else {
                weightmean=0; cumul=0;
                for (int t2=startw; t2<=high;t2++){
                    weightmean+= x[t2]*(double)t2;                     cumul+=x[t2];
                }

                if(cumul<=1.1||(high-startw<50)){					poz=floor(0.5+(weightmean/cumul));	pozs[poz]=cumul;	}
                else {
                    multiple=floor(cumul)+1;
                    multiplecumul=cumul/(double)multiple;

                    cumul2=0;high2=startw;
                    for(int k=1; k<=multiple;k++){
                        weightmean=0;cumul3=0;
                        while(cumul2<=multiplecumul*(double)k){
                            weightmean+= x[high2]*(double)high2;
                            cumul2+=x[high2];
                            cumul3+=x[high2];
                            high2++;
                        }
                    poz=floor(0.5+(weightmean/cumul3));
                    pozs[poz]=cumul3;
                    }
                }

                t=high+1;
                score[t]=0;
                inside=false;
                cumul=0;
            }
        }
    }
    return pozs;
}
